#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2000;
int a[MAXN][MAXN];
int n, m;

long long ans1, ans2, ans3;

int t1[MAXN][MAXN];
int t2[MAXN][MAXN];

void prec()
{
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            t1[i][j] = a[i][j] + t1[i][j-1];
            t2[i][j] = a[i][j] ^ t2[i][j-1];
        }
    }
    for (int j = 1; j <= m; j++)
    {
        for (int i = 1; i <= n; i++)
        {
            t1[i][j] += t1[i-1][j];
            t2[i][j] ^= t2[i-1][j];
        }
    }

//    for (int i = 1; i <= n; i++)
//    {
//        for (int j = 1; j <= m; j++)
//        {
//            cerr << t1[i][j] << " ";
//        }cerr << endl;
//    }
}

long long query1(int r1, int c1, int r2, int c2)
{
    return t1[r2][c2] - t1[r2][c1-1] - t1[r1-1][c2] + t1[r1-1][c1-1];
}

long long query2(int r1, int c1, int r2, int c2)
{
    return t2[r2][c2] ^ t2[r2][c1-1] ^ t2[r1-1][c2] ^ t2[r1-1][c1-1];
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
            cin >> a[i][j];
    }

    prec();

    int q;
    cin >> q;

    for (int Q = 1; Q <= q; Q++)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        ans1 += query1(r1, c1, r2, c2);
        ans2 += query2(r1, c1, r2, c2);

//        cerr << " = " << ans1 << " " << ans2 << endl;
    }

    cout << ans1 << " " << ans2 << " " << ans3 << endl;

    return 0;
}
/**
2 2
1 2
3 4
9
1 1 1 1
1 1 1 2
1 1 2 1
1 1 2 2
1 2 1 2
1 2 2 2
2 1 2 1
2 1 2 2
2 2 2 2


40 32 18

*/
