#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
using namespace std;

int n , k ;
struct points
    {
    int x ;
    int y ;
    double r ;
    };
vector<points> p ;

bool cmp( points c1 , points c2 )
    {
    if ( c1.r < c2.r ) return true ;
    if ( c1.r == c2.r && c1.y < c2.y ) return true ;
    if ( c1.r == c2.r && c1.y == c2.y && c1.x < c2.x ) return true ;
    return false ;
    }

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);cout.tie(NULL);

    int v1 , v2 ;
    double v3 ;

    cin >> n >> k ;
    for ( int i = 0 ; i < n ; i++ )
        {
        cin >> v1 >> v2 ;
        v3 = sqrt( v1*v1 + v2*v2 ) ;
        }

    sort( p.begin() , p.end() , cmp ) ;

    long long ans = 0 ;

     for ( int i = 0 ; i < n ; i++ )
        {
        for ( int j = i+1 ; j < n ; j++ )
            {
            if ( abs(p[i].x-p[j].x) + abs(p[i].y-p[j].y) <= k ) ans++ ;
            if ( abs(p[i].r-p[j].r) > k+(k/3) ) break ;
            }
        }

    cout << ans << endl ;

    return 0 ;
}


