#include<bits/stdc++.h>
using namespace std;
long long n,m,a[1025][1025],s,mi,tmi,xo,ps[1025][1025],pxo[1025][1025],tree[1025][5100];

void build(int indx, int l, int r, int k){
    if(l==r){
        tree[indx][k]=a[indx][l];
        return;
    }
    int mid=(l+r)/2;
    build(indx,l,mid,k*2);
    build(indx,mid+1,r,k*2+1);
    tree[indx][k]=min(tree[indx][k*2],tree[indx][k*2+1]);
}

void query(int indx, int ql, int qr, int l, int r, int k){
    if(ql<=l && r<=qr){
        tmi=min(tmi,tree[indx][k]);
        return;
    }
    if(r<ql || l>qr) return;
    int mid=(l+r)/2;
    query(indx,ql,qr,l,mid,k*2);
    query(indx,ql,qr,mid+1,r,k*2+1);
}

int main()
{
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int i,j,q,c1,c2,r1,r2;

cin>>n>>m;
for(i=1;i<=n;i++){
    for(j=1;j<=m;j++){
        cin>>a[i][j];
        ps[i][j]=a[i][j]+ps[i-1][j]+ps[i][j-1]-ps[i-1][j-1];
        pxo[i][j]=a[i][j]^pxo[i-1][j]^pxo[i][j-1]^pxo[i-1][j-1];
    }
}
for(i=1;i<=n;i++) build(i,1,m,1);

cin>>q;
while(q--){
    cin>>r1>>c1>>r2>>c2;
    s+=ps[r2][c2]-ps[r1-1][c2]-ps[r2][c1-1]+ps[r1-1][c1-1];
    xo+=pxo[r2][c2]^pxo[r1-1][c2]^pxo[r2][c1-1]^pxo[r1-1][c1-1];
    tmi=INT_MAX;
    for(i=r1;i<=r2;i++) query(i,c1,c2,1,m,1);
    mi+=tmi;
}

cout<<s<<" "<<xo<<" "<<mi;


return 0;
}
