#include<bits/stdc++.h>

#define MAXN 200002

using namespace std;

int n, a[MAXN], b[MAXN];
vector<pair<int, int> > ans;
vector<int> M[MAXN];
bool vis[MAXN];

void query(int to, int v)
{
    int val = a[v];
    if(v > to) swap(v, to);
    for(int i = v; i <= to; i ++) a[i] = val;
}
bool check()
{
    for(int i = 0; i < n; i ++)
    {
        if(a[i] != b[i]) return 0;
    }
    return 1;
}
void dfs(int v)
{
    vis[v] = 1;
    for(int to : M[v])
    {
        if(vis[to]) continue;
        //cout<<v<<" "<<to<<endl;
        dfs(to);
        query(to, v);
        ans.push_back({to, v});
    }
}
void init()
{
    for(int i = 0; i < n; i ++) M[i].clear();
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(int i = 0; i < n; i ++)
    {
        cin>>a[i];
    }
    for(int i = 0; i < n; i ++)
    {
        cin>>b[i];
    }
}
void solve()
{
    for(int d = 1; d < n; d ++)
    {
        init();
        for(int i = 0; i + d < n; i ++)
        {
            //if(i >= d) cout<<i<<" "<<d<<": "<<a[i]<<" "<<b[i - d]<<endl;
            if(i >= d && a[i] == b[i - d])
            {
                M[i].push_back(i - d);
            }
            if(a[i] == b[i + d]) M[i].push_back(i + d);
        }
        for(int i = 0; i < n; i ++) if(!vis[i] && M[i].size()) dfs(i);
    }
}
int main()
{
    read();
    solve();
    if(!check())
    {
        cout<<-1<<endl;
        return 0;
    }
    cout<<ans.size()<<'\n';
    for(int i = 0; i < ans.size(); i ++)
    {
        cout<<ans[i].first<<" "<<ans[i].second<<'\n';
    }
    return 0;
}
/*
5
2 4 3 2 1
4 4 4 3 2
*/

