#include<iostream>
#include<bits/stdc++.h>
using namespace std;
long long tabl[1500][1500];
long long sum[1500][1500];
int x[1500][1500];
int tree[1500][1500];
void buildTree(int ind, int n)
{
    for(int i=n;i>0;i--)
    {
        if(tree[ind][i<<1|1]==-1)tree[ind][i]=tree[ind][i<<1];
        else tree[ind][i]=min(tree[ind][i<<1],tree[ind][i<<1|1]);
    }
}
int query(int l, int r, int ind,int n)
{
    int ans=INT_MAX;
    l+=n;
    r+=n;
    ans=min(tree[ind][l],tree[ind][r]);
    bool fL=0,fR=0;
    for(;l<r;l>>=1,r>>=1)
    {
        if(fL==0)
        {
            if(!l&1)ans=min(ans,tree[ind][l>>1]);
            else {ans=min(ans,tree[ind][l]);fL=1;}
        }
        else if(!l&1)fL=0;
        if(fR==0)
        {
            if(r&1)ans=min(ans,tree[ind][r>>1]);
            else {ans=min(ans,tree[ind][r]);fR=1;}
        }
        else if(r&1)fR=0;
    }
    return ans;
}
int calcMin(int r1, int c1, int r2, int c2, int m)
{
    int res=INT_MAX;
    for(int i=r1;i<=r2;i++)
    {
        res=min(res,query(c1,c2,i,m));
    }
    return res;
}
int main()
{
    int n,m,q;
    long long ans=0,ansx=0,ansm=0;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>tabl[i][j];
            sum[i][j]=sum[i-1][j]+sum[i][j-1]+tabl[i][j]-sum[i-1][j-1];
            x[i][j]=x[i-1][j]^x[i][j-1]^tabl[i][j]^x[i-1][j-1];
            tree[i][m+j]=tabl[i][j];
            tree[i][m+j+1]=-1;
        }
        buildTree(i,m);
    }
    cin>>q;
    for(int t=0;t<q;t++)
    {
        int r1,c1,r2,c2;
        cin>>r1>>c1>>r2>>c2;
        long long currSum=0;
        currSum=sum[r2][c2]+sum[r1-1][c1-1]-sum[r2][c1-1]-sum[r1-1][c2];
        ans+=currSum;
        long long currX=0;
        currX=x[r2][c2]^x[r1-1][c1-1]^x[r2][c1-1]^x[r1-1][c2];
        ansx+=currX;
        ansm+=calcMin(r1,c1,r2,c2,m);
    }
    cout<<ans<<" "<<ansx<<" "<<ansm<<"\n";
}