#include<iostream>
using namespace std;
const int MAXN=100004;
typedef long long ll;
int n,m,a[1030][1030];
ll prefsum[1030][1030],prefxor[1030][1030];
int get_sum(int x,int y,int x1,int y1){
    return prefsum[x1][y1]-prefsum[x-1][y1]-prefsum[x1][y-1]+prefsum[x-1][y-1];
}
int get_xor(int x,int y,int x1,int y1){
    return prefxor[x1][y1]^prefxor[x-1][y1]^prefxor[x1][y-1]^prefxor[x-1][y-1];
}
int get_min(int x,int y,int x1,int y1){
    int res=1030;
    for(int i=x;i<=x1;i++){
        for(int j=y;j<=y1;j++){
            res=min(res,a[i-1][j-1]);
        }
    }
    return res;
}
ll ansS=0,ansX=0,ansM=0;
int main(){
    cin>>n>>m;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>a[i][j];
        }
    }
    for(int i=0;i<n;i++){
        prefsum[i][0]=0;
        prefxor[i][0]=0;
    }
    for(int i=0;i<m;i++){
        prefsum[0][i]=0;
        prefxor[0][i]=0;
    }
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            prefsum[i][j]=prefsum[i-1][j]+prefsum[i][j-1]-prefsum[i-1][j-1]+a[i-1][j-1];
            prefxor[i][j]=prefxor[i-1][j]^prefxor[i][j-1]^prefxor[i-1][j-1]^a[i-1][j-1];
        }
    }
    int q,r1,c1,r2,c2;
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>r1>>c1>>r2>>c2;
        ansS+=get_sum(r1,c1,r2,c2);
        ansX+=get_xor(r1,c1,r2,c2);
        if(n<20&&m<20){
            ansM+=get_min(r1,c1,r2,c2);
        }
    }
    cout<<ansS<<" "<<ansX<<" "<<ansM;
    return 0;
}

