#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int INF = 1e9;
const int mod = 1e9 + 7;

int a[MAX_N];
int b[MAX_N];

int lg( int x ){
    if( x == 1 ) return 0;
    return 1+lg(x/2);
}
int pw( int x ){
    if( x == 0 ) return 1;
    return 2*pw(x-1);
}

int dp[MAX_N][30];
int rmq( int i, int j ){
    //std::cerr<<"    "<<i<<" "<<j<<"\n";
    if( j == 0 ) return b[i];
    if( dp[i][j] != -1 ) return dp[i][j];
    dp[i][j] = std::min( rmq(i, j-1), rmq(i+pw(j-1), j-1) );
    //std::cerr<<" ! "<<i<<" "<<j<<" "<<dp[i][j]<<"\n";
    return dp[i][j];
}

int getRmq( int l, int r ){
    if( r < l ) return INF;
    //std::cerr<<l<<" "<<r<<"\n";
    //std::cerr<<" # "<<l<<" "<<lg(r-l+1)<<"    "<<r-pw(lg(r-l+1))+1<<" "<<lg(r-l+1)<<"\n";
    return std::min( rmq(l, lg(r-l+1)), rmq(r-pw(lg(r-l+1))+1, lg(r-l+1)) );
}

std::unordered_map<int, int> m;
std::set<int> pos[MAX_N];

int main () {

#ifndef LOCAL
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
#endif

    std::memset(dp, -1, sizeof(dp));
    int n;
    std::cin>>n;

    for( int i=0 ; i<n ; i++ ) std::cin>>a[i];
    for( int i=0 ; i<n ; i++ ) std::cin>>b[i];

    std::vector<int> v;
    int num = 0;
    for( int i=0 ; i<n ; i++ ){
        v.push_back(a[i]);
        v.push_back(b[i]);
    }
    std::sort( v.begin(), v.end() );
    v.resize( std::unique( v.begin(), v.end() ) - v.begin());
    for( int i=0 ; i<v.size() ; i++ ){
        m[v[i]] = num++;
    //    std::cerr<<v[i]<<" -> "<<num-1<<"\n";
    }

    std::vector<std::pair<int, int>> need;
    for( int i=0 ; i<n ; i++ ){
        pos[m[a[i]]].insert(i);
    //    std::cerr<<m[a[i]]<<" ins "<<i<<"\n";
        need.push_back({m[b[i]], i});
    }


    std::sort(need.begin(), need.end());
    /*
    for( auto j : need ) std::cerr<<j.first<<" "<<j.second<<"\n";
    std::cerr<<"\n\n";
    */

    std::vector<std::pair<int, int>> nas;
    for( int i=0 ; i<n ; i++ ){
        auto curr = need[i];

        if( curr.first == m[a[curr.second]] ) continue;

       // std::cerr<<curr.first<<" "<<curr.second<<"\n";
        if( b[curr.second] < a[curr.second] ){
            std::cout<<"-1\n";
            return 0;
        }
      //  std::cerr<<"---\n";
    // for( auto j : pos[curr.first] ) std::cerr<<j<<" ";
     //   std::cerr<<"\n---\n";

        auto it = pos[curr.first].lower_bound(curr.second);

        if( it != pos[curr.first].end() ){

       // std::cerr<<" ! "<<*it<<"\n";
        if( getRmq( curr.second, *it ) >= curr.first ){
        //    std::cout<<curr.second<<" "<<*it<<"\n";
            if( *it !=curr.second ){
                    nas.push_back({curr.second, *it});
            pos[curr.first].insert( curr.second );
            pos[m[a[curr.second]]].erase(curr.second);
            continue;
            }
        }
        }
        if( it != pos[curr.first].begin() ){
            it = prev(it);
            if( getRmq( *it, curr.second ) >= curr.first ){
            //    std::cout<<*it<<" "<<curr.second<<"\n";
                if( *it != curr.second ){
                        nas.push_back({*it, curr.second});
                pos[curr.first].insert( curr.second );
                pos[m[a[curr.second]]].erase(curr.second);
                continue;
                }

            }
        }
        return std::cout<<"-1\n", 0;
    }

    std::cout<<nas.size()<<"\n";
    for( auto j : nas ){
            if( j.first > j.second ) std::swap(j.first, j.second);
            std::cout<<j.first+1<<" "<<j.second+1<<"\n";
    }

    return 0;
}
/*
5
2 4 3 2 1
4 4 4 3 2

*/
