#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int MAX_N = 1024 + 42;
const int INF = 1e9;
const int mod = 1e9 + 7;

int a[MAX_N][MAX_N];
int pref[MAX_N][MAX_N];
int xPref[MAX_N][MAX_N];

int main () {

#ifndef LOCAL
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
#endif

    int n, m;
    std::cin>>n>>m;
    for( int i=1 ;i<=n ; i++ ){
        for( int j=1 ; j<=m; j++ ){
            std::cin>>a[i][j];
        }
    }

    for( int i=1 ; i<=n ; i++ ){
        for( int j=1 ; j<=m ; j++ ){
            pref[i][j] = pref[i-1][j] +pref[i][j-1] - pref[i-1][j-1] + a[i][j];
            xPref[i][j] = xPref[i-1][j] ^ xPref[i][j-1] ^ xPref[i-1][j-1] ^ a[i][j];
        }
    }

    int q;
    std::cin>>q;
    ll nasSum = 0;
    ll nasXor = 0;
    while( q --> 0 ){
        int x1, y1, x2, y2;
        std::cin>>x1>>y1>>x2>>y2;
        ll currSum = pref[x2][y2] - pref[x1-1][y2] - pref[x2][y1-1] + pref[x1-1][y1-1];
        nasSum += currSum;
        ll currXor = xPref[x2][y2] ^ xPref[x1-1][y2] ^ xPref[x2][y1-1] ^ xPref[x1-1][y1-1];
        nasXor += currXor;

    }

    std::cout<<nasSum<<" "<<nasXor<<" 1"<<"\n";


    return 0;
}
