#include<iostream>
using namespace std;
const int MAXN = 1024;
const int MAXM = 1024;
const int LOG = 10;
const long long int INF = 1e9+9;
int lg[MAXN];
int a[MAXN][MAXM];
int sum[MAXN][MAXM],x[MAXN][MAXM];
short RMQ[LOG][LOG][MAXN][MAXM];
int main(){
    int i,j,log,log1;
    for(i=2;i<MAXN;i++){
        lg[i]=lg[i-1];
        if(i==(1<<(lg[i]+1))) lg[i]++;
    }
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n,m;
    cin>>n>>m;
    for(i=0;i<n;i++){
        for(j=0;j<m;j++){
            cin>>a[i][j];
        }
    }
    sum[0][0]=a[0][0];
    x[0][0]=a[0][0];
    for(i=1;i<n;i++){
        sum[i][0]=sum[i-1][0]+a[i][0];
        x[i][0]=x[i-1][0]^a[i][0];
    }
    for(j=1;j<m;j++){
        sum[0][j]=sum[0][j-1]+a[0][j];
        x[0][j]=x[0][j-1]^a[0][j];
    }
    for(i=1;i<n;i++){
        for(j=1;j<m;j++){
            sum[i][j]=sum[i][j-1]+sum[i-1][j]-sum[i-1][j-1]+a[i][j];
            x[i][j]=x[i-1][j]^x[i][j-1]^x[i-1][j-1]^a[i][j];
        }
    }
    for(i=0;i<n;i++){
        for(j=0;j<m;j++){
            RMQ[0][0][i][j]=a[i][j];
        }
    }
    for(i=0;i<n;i++){
        for(log=1;log<LOG;log++){
            for(j=0;j<m;j++){
                RMQ[0][log][i][j]=min(RMQ[0][log-1][i][j],RMQ[0][log-1][i][j+(1<<(log-1))]);
            }
        }
    }
    for(log=1;log<LOG;log++){
        for(i=0;i<n;i++){
            for(j=0;j<m;j++){
                RMQ[log][0][i][j]=min(RMQ[log-1][0][i][j],RMQ[log-1][0][i+(1<<(log-1))][j]);
            }
        }
    }
    for(log1=1;log1<LOG;log1++){
        for(i=0;i<n;i++){
            for(log=1;log<LOG;log++){
                for(j=0;j<m;j++){
                    RMQ[log1][log][i][j]=min(min(RMQ[log1-1][log-1][i][j],RMQ[log1-1][log-1][i+(1<<(log1-1))][j]),
                                             min(RMQ[log1-1][log-1][i][j+(1<<(log-1))],RMQ[log1-1][log-1][i+(1<<(log1-1))][j+(1<<(log-1))]));
                }
            }
        }
    }
    int q;
    cin>>q;
    int x1,y1,x2,y2;
    int SUM=0,ans=0,MIN=0;
    int curr_sum,curr_x,curr_min;
    while(q--){
        cin>>x1>>y1>>x2>>y2;
        x1--; y1--; x2--; y2--;
        int lg1=lg[x2-x1],lg2=lg[y2-y1];
        curr_min=min(min(RMQ[lg1][lg2][x1][y1],RMQ[lg1][lg2][x1][y2-(1<<lg2)+1]),
        min(RMQ[lg1][lg2][x2-(1<<lg1)+1][y1],RMQ[lg1][lg2][x2-(1<<lg1)+1][y2-(1<<lg2)+1]));
        curr_sum=sum[x2][y2];
        curr_x=x[x2][y2];
        if(x1==0 && y1==0) curr_sum=sum[x2][y2],curr_x=x[x2][y2];
        else if(x1==0) curr_sum-=sum[x2][y1-1],curr_x^=x[x2][y1-1];
        else if(y1==0) curr_sum-=sum[x1-1][y2],curr_x^=x[x1-1][y2];
        else{
            curr_sum=sum[x2][y2]-sum[x2][y1-1]-sum[x1-1][y2]+sum[x1-1][y1-1];
            curr_x^=(x[x2][y1-1]^x[x1-1][y2]^x[x1-1][y1-1]);
        }
        SUM+=curr_sum;
        ans+=curr_x;
        MIN+=curr_min;
    }
    cout<<SUM<<" "<<ans<<" "<<MIN<<"\n";
    return 0;
}
