#include <bits/stdc++.h>
using namespace std;
const int MAX_N = 1024;
int price[MAX_N][MAX_N];
unsigned long long s, x, summin;
int n, m;
unsigned long long prefixsum[MAX_N][MAX_N];
unsigned long long prefixXor[MAX_N][MAX_N];
unsigned long long segmMin[4 * MAX_N * MAX_N];
void build_tree(int curr, int first, int last)
{
    if(last < first)
    {
        return;
    }
    if(first == last)
    {
        segmMin[curr] = price[first / m][first % m];
        return;
    }
    int mid = (first + last) / 2;
    build_tree(curr * 2, first, mid);
    build_tree(curr * 2 + 1, mid + 1, last);
    segmMin[curr] = min(segmMin[curr * 2], segmMin[curr * 2 + 1]);
}
int findMin(int curr, int first, int last, int from, int to)
{
    if(from > last || to < first )
    {
        return INT_MAX;
    }
    if(first >= from && last <= to)
    {
        return segmMin[curr];
    }
    int mid = (first + last) / 2;
    return min(findMin(curr * 2, first, mid, from, to), findMin(curr * 2 + 1, mid + 1, last, from, to));
}
void f(int y1, int x1, int y2, int x2)
{
    int sumres = 0, xres = 0, minres = 10000000;
    if(n <= 16)
    {
        for(int i = y1; i <= y2; i++)
        {
            for(int j = x1; j <= x2; j++)
            {
                //minres = min(minres, price[i][j]);
                xres = xres ^ price[i][j];
            }
        }
    }
    s += prefixsum[y2][x2];
    for(int i = y1; i <= y2; i++)
    {
        minres = min(findMin(1, 0, n * m - 1, i * m + x1, i * m + x2), minres);
    }
    if(x1 > 0)
    {
        s -= prefixsum[y2][x1 - 1];
    }
    if(y1 > 0)
    {
        s -= prefixsum[y1 - 1][x2];
    }
    if(x1 > 0 && y1 > 0)
    {
        s += prefixsum[y1 - 1][x1 - 1];
    }
    /*xres = prefixXor[y2][x2];
    if(x1 > 0)
    {
        xres = prefixXor[y2][x1 - 1] ^ xres;
    }
    if(y1 > 0)
    {
        xres = prefixXor[y1 - 1][x2] ^ xres;
    }
    if(x1 > 0 && y1 > 0)
    {
        xres = prefixXor[y1 - 1][x1 - 1] ^ xres;
    }*/
    x += xres;
    summin += minres;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            cin >> price[i][j];
            if(i == 0 && j == 0)
            {
                prefixsum[i][j] = price[i][j];
                prefixXor[i][j] = price[i][j];
            }
            else
            {
                if(j == 0)
                {
                    prefixsum[i][j] = prefixsum[i - 1][j] + price[i][j];
                    prefixXor[i][j] = prefixXor[i - 1][j] ^ price[i][j];
                }
                else if(i == 0)
                {
                    prefixsum[i][j] = prefixsum[i][j - 1] + price[i][j];
                    prefixXor[i][j] = prefixXor[i][j - 1] ^ price[i][j];
                }
                else
                {
                    prefixsum[i][j] = prefixsum[i][j - 1] + prefixsum[i - 1][j] - prefixsum[i - 1][j - 1] + price[i][j];
                    prefixXor[i][j] = prefixXor[i][j - 1] ^ prefixXor[i - 1][j] ^ prefixsum[i - 1][j - 1] ^ price[i][j];
                }
            }
        }
    }
    build_tree(1, 0, n * m - 1);
    int q;
    cin >> q;
    for(int i = 0; i < q; i++)
    {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        r1--;
        c1--;
        r2--;
        c2--;
        f(r1, c1, r2, c2);
    }
    cout << s << " " << x << " " << summin;
    return 0;
}
