#include<iostream>

using namespace std;

int table[1025][1025];
int xorTable[1025][1025];
int sumTable[1025][1025];
int main() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> table[i][j];
            xorTable[i][j] = xorTable[i][j - 1] ^ table[i][j];
            sumTable[i][j] = sumTable[i][j - 1] + table[i][j];
        }
    }
    int q;
    long long totalS = 0, totalX = 0, totalM = 0;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int localX = 0, localM = 2048;
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        for (int r = r1; r <= r2; r++) {
            for (int c = c1; c <= c2; c++) {
                localM = min(localM, table[r][c]);
            }
            totalS += sumTable[r][c2] - sumTable[r][c1 - 1];
            localX ^= xorTable[r][c2] ^ xorTable[r][c1 - 1];
            //printf("  row: %d\n    row xor: %d\n    localX: %d\n", r, xorTable[r][c1 - 1] ^ xorTable[r][c2], localX);
        }

        totalX += localX;
        totalM += localM;
    }
    cout << totalS << " " << totalX << " " << totalM << endl;
    return 0;
}
