#include<iostream>
#include<vector>

using namespace std;

int table[1025][1025];
int xorTable[1025][1025];
long long sumTable[1025][1025];
vector<pair<int, int>> byValue[1025];

bool inRange(int v, int i, int r1, int c1, int r2, int c2) {
    return (byValue[v][i].first >= r1 && byValue[v][i].second >= c1 &&
            byValue[v][i].first <= r2 && byValue[v][i].second <= c2);
}
int main() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> table[i][j];
            xorTable[i][j] = xorTable[i][j - 1] ^ table[i][j];
            sumTable[i][j] = sumTable[i][j - 1] + table[i][j];
            byValue[table[i][j]].push_back({ i,j });
        }
    }
    int q;
    long long totalS = 0, totalX = 0, totalM = 0;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int localX = 0, localM = 0;
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        for (int r = r1; r <= r2; r++) {
            //totalS += sumTable[r][c2] - sumTable[r][c1 - 1];
            localX ^= xorTable[r][c2] ^ xorTable[r][c1 - 1];
            //printf("  row: %d\n    row xor: %d\n    localX: %d\n", r, xorTable[r][c1 - 1] ^ xorTable[r][c2], localX);
        }
        for (int v = 0; localM == 0; v++) {
            for (int j = 0; j < byValue[v].size(); j++) {
                if (inRange(v, j, r1, c1, r2, c2)) {
                    localM = v;
                    break;
                }
            }
        }

        totalX += localX;
        totalM += localM;
    }
    cout << totalS << " " << totalX << " " << totalM << endl;
    return 0;
}
