#include<iostream>
using namespace std;
const int MAXN = 1030;
int ksor[MAXN][MAXN];
long long sum[MAXN][MAXN];
int a[MAXN][MAXN];

int bigtree[4*MAXN],tree[4*MAXN][4*MAXN];
void build_smalltree(int ind,int l,int r,int bigind){
    if(l==r){
        tree[bigind][ind]=a[bigind][l+1];
        return;
    }
    int m = (l+r)/2;
    build_smalltree(2*ind,l,m,bigind);
    build_smalltree(2*ind+1,m+1,r,bigind);
    tree[bigind][ind]=min(tree[bigind][2*ind],tree[bigind][2*ind+1]);
    return;
}
/*void build_bigtree(int ind,int l,int r){ /// l i  r - za koi redove e
    if(l==r){
        build_smalltree(1,0,m-1,ind,l);
        //bigtree[ind];
        return;
    }
    int m = (l+r)/2;
    build_bigtree(2*ind,l,m);
    build_bigtree(2*ind+1,m+1,r);
    //bigtree[ind]=min(bigtree[2*ind,])
}*/
int query(int ind,int l,int r,int ql,int qr,int bigind){

    if(ql<=l && r<=qr){
        /*cout<<" za "<<ql<<" "<<qr<<" v curr = "<<l<<" "<<r<<" ans = ";
        cout<<"1. "<<tree[bigind][ind]<<"\n";*/
        return tree[bigind][ind];
    }
    int m=(l+r)/2;
    int currmin = 1024;
    if(ql<=m) currmin = query(2*ind,l,m,ql,qr,bigind);
    if(qr>m) currmin = query(2*ind+1,m+1,r,ql,qr,bigind);
    /*cout<<" za "<<ql<<" "<<qr<<" v curr = "<<l<<" "<<r<<" ans = ";
    cout<<currmin<<"\n";*/
    return currmin;
}
int main() {
    int n,m;
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            cin>>a[i][j];
            sum[i][j]=sum[i][j-1]+sum[i-1][j]-sum[i-1][j-1]+a[i][j];
            ksor[i][j]=ksor[i][j-1]^ksor[i-1][j]^ksor[i-1][j-1]^a[i][j];
        }
    }
    for(int i=1;i<=n;i++){
        build_smalltree(1,0,n-1,i);
    }
    int q;
    int suma = 0,XOR = 0,MIN=0;
    cin>>q;
    int i1,j1,i2,j2,currmin;
    while(q--){
        cin>>i1>>j1>>i2>>j2;
        currmin = a[i1][j1];
        for(int i=i1;i<=i2;i++){
            currmin = min(currmin,query(1,0,n-1,j1-1,j2-1,i));
        }
        //cout<<"min = "<<currmin<<"\n";
        MIN+=currmin;
        suma+=sum[i2][j2]-sum[i2][j1-1]-sum[i1-1][j2]+sum[i1-1][j1-1];
        XOR+=ksor[i2][j2]^ksor[i2][j1-1]^ksor[i1-1][j2]^ksor[i1-1][j1-1];
    }
    cout<<suma<<" "<<XOR<<" "<<MIN<<"\n";
    return 0;
}

