#include<bits/stdc++.h>
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=1030;
const int mod=1e9+7;
const int maxq=5e5+2;

int n, m, q;
ll prefix[maxn][maxn];
ll a[maxn][maxn];
ll x[maxn][maxn];

struct query{
    int a, b, c, d;
};

bool operator < (const query& left, const query& right){
    if(left.a==right.b){
        if(left.b==right.b){
            if(left.c==right.c){
                return left.d<right.d;
            }else{
                return left.c<right.c;
            }
        }else{
            return left.b<right.b;
        }
    }else{
        return left.a<right.a;
    }
}

ll ans_p=0, ans_x=0, ans_m=0;

int main() {
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;

for(int i=1; i<=n; i++){
    for(int j=1; j<=m; j++){
        cin>>a[i][j];
    }
}

for(int i=1; i<=n; i++){
    for(int j=1; j<=m; j++){
        prefix[i][j] = a[i][j] + prefix[i-1][j] + prefix[i][j-1] - prefix[i-1][j-1];
        x[i][j] = a[i][j] ^ x[i-1][j] ^ x[i][j-1] ^ x[i-1][j-1];
        //mins[i][j] = min(a[i][j], min(mins[i-1][j], mins[i][j-1]));
    }
}

cin>>q;

query queries[maxq];

for(int i=0; i<q; i++){
    cin>>queries[i].a>>queries[i].b>>queries[i].c>>queries[i].d;
}

sort(queries, queries+n);
ll curr_min=INT_MAX;

for(int i=0; i<q; i++){
    int x1=queries[i].a;
    int y1=queries[i].b;
    int x2=queries[i].c;
    int y2=queries[i].d;

    ans_p+=prefix[x2][y2] - prefix[x2][y1-1] - prefix[x1-1][y2] + prefix[x1-1][y1-1];
    ans_x+=x[x2][y2] ^ x[x2][y1-1] ^ x[x1-1][y2] ^ x[x1-1][y1-1];

    if(i==0 or x1!=queries[i-1].a or y1!=queries[i-1].b or x2!=queries[i-1].c or y2!=queries[i-1].d){
        curr_min=INT_MAX;

        for(int i=x1; i<=x2; i++){
            for(int j=y1; j<=y2; j++){
                curr_min=min(curr_min, a[i][j]);
            }
        }
    }
    ans_m+=curr_min;
}
cout<<ans_p<<" "<<ans_x<<" "<<ans_m<<endl;

return 0;
}