#include<bits/stdc++.h>
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=5e5+3;
const int mod=1e9+7;

int n, k;
pii points[maxn];

ll nas=0;

bool cmp(pii left, pii right){
    return left.first<right.first;
}

int find_l(int x){
    int l=0, r=x, m;

    while(l<r-1){

        m=(l+r)/2;
        //cerr<<"find_l m="<<m<<endl;

        if(abs(points[x].first-points[m].first)<=k){
            l=m;
        }else{
            r=m;
        }
    }

    return l;
}

int find_r(int x){
    int l=x, r=n, m;

    while(l<r-1){
        m=(l+r)/2;
        //cerr<<"find_r m="<<m<<endl;

        if(abs(points[x].first-points[m].first)<=k){
            l=m;
        }else{
            r=m;
        }
    }

    return r;
}

int main() {
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>k;

for(int i=0; i<n; i++){
    cin>>points[i].first>>points[i].second;
}

sort(points, points+n);

for(int i=0; i<n; i++){
    int left=0, right=n;
    left=find_l(i);
    right=find_r(i);

    nas+=i-left + right-i;

    //cerr<<"ot "<<i+1<<": "<<left+1<<" to "<<right+1<<endl;
}
cout<<nas/2;
return 0;
}



