#include<bits/stdc++.h>
#define lli int
#define endl "\n"
using namespace std;
struct node{
    lli first, second, third;
    const bool operator <(node p){
        if(first!=p.first)return first<p.first;
        if(second!=p.second)return second<p.second;
        return third<p.third;
    }
};
const lli MAXN=200005, INF=2000000005;
lli a[MAXN], b[MAXN], N, tree[4*MAXN];
vector<pair<lli, lli>> ans;
vector<node> ev;
bool fl;
void build(lli ind, lli l, lli r){
    if(l==r){
        tree[ind]=a[l];
        return;
    }
    lli mid=(l+r)/2;
    build(2*ind, l, mid);
    build(2*ind+1, mid+1, r);
    tree[ind]=max(tree[2*ind], tree[2*ind+1]);
    return;
}
void update(lli ind, lli l, lli r, lli q, lli d){
    if(r<q or l>q)return;
    if(l==r){
        tree[ind]=d;
        return;
    }
    lli mid=(l+r)/2;
    update(2*ind, l, mid, q, d);
    update(2*ind+1, mid+1, r, q, d);
    tree[ind]=max(tree[2*ind], tree[2*ind+1]);
    return;
}
lli query(lli ind, lli l, lli r, lli ql, lli qr){
    if(r<ql or l>qr)return 0;
    if(ql<=l and qr>=r)return tree[ind];
    lli mid=(l+r)/2;
    return max(query(2*ind, l, mid, ql, qr), query(2*ind+1, mid+1, r, ql, qr));
}
lli bin_search(lli l, lli r, lli x, lli now){
    if(r<l)return -1;
    while(l<r-1){
        lli mid=(l+r)/2;
        if(mid<now){
            if(query(1, 0, N-1, mid, now)<x)r=mid;
            else l=mid;
        }else{
            if(query(1, 0, N-1, now, mid)<x)l=mid;
            else r=mid;
        }
    }
    if(r<now){
        if(query(1, 0, N-1, r, now)==x)return r;
        else if(query(1, 0, N-1, l, now)==x)return l;
        return -1;
    }
    if(query(1, 0, N-1, now, l)==x)return l;
    else if(query(1, 0, N-1, now, r)==x)return r;
    return -1;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N;
    for(lli i=0; i<N; i++)cin>>a[i];
    for(lli i=0; i<N; i++){
        cin>>b[i];
        ev.push_back({b[i], a[i], i});
    }
    build(1, 0, N-1);
    sort(ev.begin(), ev.end());
    for(lli i=0; i<ev.size(); i++){
        lli now=ev[i].third;
        if(b[now]<a[now]){
            fl=1;
            break;
        }
        if(b[now]==a[now]){
            update(1, 0, N-1, now, INF);
            continue;
        }
        lli p=bin_search(0, now-1, b[now], now);
        if(p==-1)p=bin_search(now+1, N-1, b[now], now);
        if(p==-1){
            fl=1;
            break;
        }else{
            update(1, 0, N-1, now, INF);
            if(p<now)ans.push_back({p, now});
            else ans.push_back({now, p});
        }
    }
    if(fl==1)cout<<"-1"<<endl;
    else{
        cout<<ans.size()<<endl;
        for(lli i=0; i<ans.size(); i++){
            cout<<ans[i].first<<" "<<ans[i].second<<endl;
        }
    }
    return 0;
}

