#include<bits/stdc++.h>
#define lli int
#define endl "\n"
using namespace std;
struct node{
    lli first, second, third;
    const bool operator <(node p){
        if(first!=p.first)return first<p.first;
        if(second!=p.second)return second<p.second;
        return third<p.third;
    }
};
const lli MAXN=200005, INF=2000000005;
lli a[MAXN], b[MAXN], N, tree[2][4*MAXN], posle[2][MAXN], predi[2][MAXN];
vector<pair<lli, lli>> ans;
vector<node> ev;
queue<lli> q;
bool fl;
void build(lli ind, lli l, lli r){
    if(l==r){
        tree[0][ind]=0;
        tree[1][ind]=INF;
        return;
    }
    lli mid=(l+r)/2;
    build(2*ind, l, mid);
    build(2*ind+1, mid+1, r);
    tree[0][ind]=0;
    tree[1][ind]=INF;
    return;
}
void update(lli id, lli ind, lli l, lli r, lli q, lli d){
    if(r<q or l>q)return;
    if(l==r){
        tree[id][ind]=d;
        return;
    }
    lli mid=(l+r)/2;
    update(id, 2*ind, l, mid, q, d);
    update(id, 2*ind+1, mid+1, r, q, d);
    if(id==0)tree[id][ind]=max(tree[id][2*ind], tree[id][2*ind+1]);
    else tree[id][ind]=min(tree[id][2*ind], tree[id][2*ind+1]);
    return;
}
lli query(lli id, lli ind, lli l, lli r, lli x, lli pos){
    if(l==r){
        return l;
    }
    lli mid=(l+r)/2;
    if(id==0){
        if(pos==0){
            if(tree[id][2*ind+1]>=x)return query(id, 2*ind+1, mid+1, r, x, pos);
            return query(id, 2*ind, l, mid, x, pos);
        }
        if(tree[id][2*ind]>=x)return query(id, 2*ind, l, mid, x, pos);
        return query(id, 2*ind+1, mid+1, r, x, pos);
    }
    if(pos==0){
        if(tree[id][2*ind+1]<x)return query(id, 2*ind+1, mid+1, r, x, pos);
        return query(id, 2*ind, l, mid, x, pos);
    }
    if(tree[id][2*ind]<x)return query(id, 2*ind, l, mid, x, pos);
    return query(id, 2*ind+1, mid+1, r, x, pos);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N;
    for(lli i=0; i<N; i++)cin>>a[i];
    for(lli i=0; i<N; i++){
        cin>>b[i];
        ev.push_back({b[i], a[i], i});
        if(b[i]<a[i])fl=1;
    }
    build(1, 0, N-1);
    update(0, 1, 0, N-1, 0, a[0]);
    update(1, 1, 0, N-1, 0, b[0]);
    for(lli i=1; i<N; i++){
        predi[0][i]=query(0, 1, 0, N-1, b[i], 0);
        predi[1][i]=query(1, 1, 0, N-1, b[i], 0);
        update(0, 1, 0, N-1, i, a[i]);
        update(1, 1, 0, N-1, i, b[i]);
    }
    build(1, 0, N-1);
    update(0, 1, 0, N-1, N-1, a[N-1]);
    update(1, 1, 0, N-1, N-1, b[N-1]);
    for(lli i=N-2; i>=0; i--){
        posle[0][i]=query(0, 1, 0, N-1, b[i], 1);
        posle[1][i]=query(1, 1, 0, N-1, b[i], 1);
        update(0, 1, 0, N-1, i, a[i]);
        update(1, 1, 0, N-1, i, b[i]);
    }
    sort(ev.begin(), ev.end());
    for(lli i=0; i<ev.size() and fl==0; i++){
        lli now=ev[i].third;
        lli p=predi[0][now];
        if(a[now]==b[now])continue;
        if(a[p]==b[now] and predi[1][now]<=p){
            if(p<now)ans.push_back({p, now});
            else ans.push_back({now, p});
        }else{
            p=posle[0][now];
            if(a[p]==b[now] and posle[1][now]>=p){
                if(p<now)ans.push_back({p, now});
                else ans.push_back({now, p});
            }else fl=1;
        }
    }
    if(fl==1)cout<<"-1"<<endl;
    else{
        cout<<ans.size()<<endl;
        for(lli i=0; i<ans.size(); i++){
            cout<<ans[i].first<<" "<<ans[i].second<<endl;
        }
    }
    return 0;
}


