#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 2e5+10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, a[MAXN], b[MAXN];

unordered_map < int, int > mp;
vector < int > diff;
void read_arrays()
{
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        diff.push_back(a[i]);
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
        diff.push_back(b[i]);
    }
}

void compress()
{
    sort(diff.begin(), diff.end());
    mp[diff[0]] = 1;
    int cnt = 1;
    for (int i = 1; i < diff.size(); ++ i)
    {
        if(diff[i] != diff[i-1])
        {
            cnt ++;
            mp[diff[i]] = cnt;
        }
    }
    for (int i = 1; i <= n; ++ i)
    {
        a[i] = mp[a[i]];
        b[i] = mp[b[i]];
    }
   /* cout << "after compression" << endl;
    for (int i = 1; i <= n; ++ i)
        cout << a[i] << " ";
    cout << endl;
    for (int i =1; i <= n; ++ i)
    {
        cout << b[i] << " ";
    }
    cout << endl; */
}
int t[MAXN * 4], g[MAXN * 4];

void build_tree(int i, int l, int r)
{
    if(l == r)
    {
        t[i] = a[l];
        return;
    }
    int mid = (l + r)/2;
    build_tree(2*i, l, mid);
    build_tree(2*i+1, mid+1, r);
    t[i] = max(t[2*i], t[2*i+1]);
}
int ql, qr;
int query(int i, int l, int r)
{
     if(ql > r || qr < l)return 0;
    if(ql <= l && r <= qr)return t[i];
    int mid = (l + r)/2;
    return max(query(2*i, l, mid), query(2*i+1, mid+1, r));
}

void build_tree_2(int i, int l, int r)
{
    if(l == r)
    {
        g[i] = b[l];
        return;
    }
    int mid = (l + r)/2;
    build_tree_2(2*i, l, mid);
    build_tree_2(2*i+1, mid+1, r);
    g[i] = min(g[2*i], g[2*i+1]);
}
int query_2(int i, int l, int r)
{
    if(ql > r || qr < l)return 1e9;
    if(ql <= l && r <= qr)return g[i];
    int mid = (l + r)/2;
    return min(query_2(2*i, l, mid), query_2(2*i+1, mid+1, r));
}
vector < pair < int, int > > p;
int x[MAXN], y[MAXN];
void pre()
{
    for (int i = 1; i <= n; ++ i)
        p.push_back(make_pair(a[i], i));
}
void find_segments()
{
    for (int i = 1; i <= n; ++ i)
    {
        int xx = 1, yy = i, mid, leftj = i;
        while (xx <= yy)
        {
            mid = (xx + yy)/2;
            ql = mid;
            qr = i;
            if(query(1, 1, n) > a[i] || query_2(1, 1, n) < a[i])
            {
                xx = mid+1;
            }
            else
            {
                yy = mid - 1;
                leftj = mid;
            }
        }
        xx = i;
        yy = n;
        int rightj = n;
        while (xx <= yy)
        {
            mid = (xx + yy)/2;
            ql = i;
            qr = mid;
           // cout << i << " mid right -> " << mid << endl;
            if(query(1, 1, n) > a[i] || query_2(1, 1, n) < a[i])
            {
                //cout << query(1, 1, n) << ", " << query_2(1, 1, n) << endl;
                yy = mid-1;
            }
            else
            {
               // cout << "in" << endl;
                xx = mid + 1;
                rightj = mid;
            }
        }
        x[i] = leftj;
        y[i] = rightj;

    }
}
vector < pair < int, int > > start[MAXN];
void solve()
{
    for (int i = 1; i <= n; ++ i)
        start[x[i]].push_back(make_pair(a[i], y[i]));
    priority_queue < pair < int, int > > pq;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 0; j < start[i].size(); ++ j)
            pq.push(start[i][j]);

        while(!pq.empty() && pq.top().second < i)pq.pop();
        int make = a[i];
        if(!pq.empty())make = max(make, pq.top().first);
        if(make != b[i])
        {
            cout << -1 << endl;
            return;
        }
    }
    cout << n << endl;
    for (int i = 1; i <= n; ++ i)
        cout << x[i]-1 << " " << y[i]-1 << endl;
}
int main()
{
    speed();
    read_arrays();
    compress();
    build_tree(1, 1, n);
    build_tree_2(1, 1, n);
    pre();
    find_segments();
    solve();
    return 0;
}
