#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 2000;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m;
long long a[MAXN][MAXN];
long long prefsum[MAXN][MAXN], prefxor[MAXN][MAXN];
void read_table()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
            cin >> a[i][j];
    }
}

void build_tables()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            prefsum[i][j] = prefsum[i-1][j] + prefsum[i][j-1] - prefsum[i-1][j-1] + a[i][j];
            prefxor[i][j] = prefxor[i-1][j] ^ prefxor[i][j-1] ^ prefxor[i-1][j-1] ^ a[i][j];
        }
    }
}

long long sum_subtable(int x, int y, int xx, int yy)
{
    return (prefsum[xx][yy] - prefsum[x-1][yy] - prefsum[xx][y-1] + prefsum[x-1][y-1]);
}
long long xor_subtable(int x, int y, int xx, int yy)
{
    return (prefxor[xx][yy] ^ prefxor[x-1][yy] ^ prefxor[xx][y-1] ^ prefxor[x-1][y-1]);
}

int is[1025][33][260], cnt[1025][33][260];
long long ima(int number, int x, int y, int xx, int yy)
{
    return (cnt[number][xx][yy] - cnt[number][x-1][yy] - cnt[number][xx][y-1] + cnt[number][x-1][y-1] > 0);
}
void solve()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
            is[a[i][j]][i][j] = 1;
    }
    for (int x = 0; x <= 1024; ++ x)
    {
        for (int i = 1; i <= n; ++ i)
        {
            for (int j = 1; j <= m; ++ j)
                cnt[x][i][j] = cnt[x][i-1][j] + cnt[x][i][j-1] - cnt[x][i-1][j-1] + is[x][i][j];
        }
    }
}
long long s, resx, minn = 0;
void read_queries()
{
    int q;
    cin >> q;
    int x, y, xx, yy;
    int currmin, i;
    while(q --)
    {
        cin >> x >> y >> xx >> yy;
        s += sum_subtable(x, y, xx, yy);
        resx += xor_subtable(x, y, xx, yy);
        currmin = 1e9 + 10;

        for (int i = 0; i <= 1024 && (currmin == 1e9+10); ++ i)
            if(ima(i, x, y, xx, yy))currmin = i;
        minn += currmin;
    }
    cout << s << " " << resx << " " << minn << endl;
}
int main()
{
    speed();
    read_table();
    build_tables();
    solve();
    read_queries();
    return 0;
}
