#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=2e5;
int a[MAXN];
int b[MAXN];
int tree[4*MAXN];
pair<int, int > order[MAXN];
vector<pair<int,int>> ans;
int st[MAXN][20];
void build(int vr, int l, int r)
{
    if(l==r)
    {
        tree[vr]=a[l];
        return;
    }
    int mid=(l+r)>>1;
    build(2*vr,l,mid);
    build(2*vr+1,mid+1,r);
    tree[vr]=max(tree[2*vr],tree[2*vr+1]);
}
void update(int vr, int l, int r, int ind)
{
    if(l==r)
    {
        tree[vr]=2e9;
        return;
    }
    int mid=(l+r)>>1;
    if(ind<=mid)update(2*vr,l,mid,ind);
    else update(2*vr+1,mid+1,r,ind);
    tree[vr]=max(tree[2*vr],tree[2*vr+1]);
}
int query(int vr, int l,int r, int L, int R)
{
    if(r<L||l>R)return 0;
    if(l>=L&&r<=R)return tree[vr];
    int mid=(l+r)>>1;
    return max(query(2*vr,l,mid,L,R),query(2*vr+1,mid+1,r,L,R));
}
queue<int> q;
int main()
{
    /*ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);*/

    int n;
    cin>>n;
    for(int i=0; i<n; i++)
    {
        cin>>a[i];
    }
    for(int i=0; i<n; i++)
    {
        cin>>b[i];
        order[i]= {b[i],i};
    }
    sort(order,order+n);
    //sparse_table();
    build(1,0,n-1);
    for(int i=0; i<n; i++)
    {
        int ind=order[i].second;
        int ptr1=ind-1;
        int ptr2=ind+1;
        if(b[ind]!=b[order[i-1].second])
        {
            /*while(!q.empty())
            {
                update(1,0,n-1,q.front());
                q.pop();
            }*/
        }
        if(a[ind]==b[ind])
        {
            q.push(ind);
            continue;
        }
        if(a[ind]>b[ind])
        {
            cout<<-1<<endl;
            return 0;
        }
        int l=0, r=ind-1;
        int k;
        while(l!=r&&l<n&&r>=0)
        {
            int mid=(l+r)>>1;
            k=query(1,0,n-1,mid,ind-1);
            //cout<<l<<" "<<r<<" "<<k<<" "<<b[ind]<<endl;
            if(k>b[ind])l=mid+1;
            else if(k<b[ind])r=mid-1;
            else if(k==b[ind])
            {
                ans.push_back({mid,ind});
                break;
            }
            if(l==r)
            {
                k=query(1,0,n-1,l,ind-1);
                if(k==b[ind])
                {
                    ans.push_back({l,ind});
                    break;
                }
            }
        }
        if(k==b[ind])
        {
            q.push(ind);
            continue;
        }

        l=ind+1;
        r=n-1;
       /* while(l!=r&&l<n&&r>=0)
        {
            int mid=(l+r)>>1;

            k=query(1,0,n-1,ind+1,mid);
            //cout<<l<<" "<<r<<" "<<k<<" "<<b[ind]<<endl;
            if(k>b[ind])r=mid-1;
            else if(k<b[ind])l=mid+1;
            else if(k==b[ind])
            {
                ans.push_back({ind,mid});
                break;
            }
            if(l==r)
            {
                k=query(1,0,n-1,ind+1,r);
                if(k==b[ind])
                {
                    ans.push_back({ind,r});
                    break;
                }
            }
        }*/
        if(k==b[ind])
        {
            q.push(ind);
            continue;
        }
        else cout<<-1<<endl;
        return 0;

    }
    cout<<ans.size()<<endl;
    for(int i=0; i<ans.size(); i++)
    {
        cout<<ans[i].first<<" "<<ans[i].second<<endl;
    }
}
/**
5
2 1 1 2 1
2 2 2 2 2

10
2 1 1 1 2 5 2 4 1 3
2 1 2 2 2 5 5 5 4 3
*/
