#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=1025;
int a[2][MAXN][MAXN];
int st[MAXN][MAXN][20];
int n,m;
int lg=0;
void sparse_table()
{
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            st[i][j][0]=a[0][i][j];
        }
    }
    for(int k=0; k<n; k++)
    {
        for(int j=1; j<=lg; j++)
        {
            for(int i=0; i<m; i++)
            {
                st[k][i][j]=min(st[k][i][j-1],st[k][i+(1<<(j-1))][j-1]);
            }
        }
    }
}
int RMQ(int k, int l,int r)
{
    int logQ=log2(r-l+1);
    return min(st[k][l][logQ],st[k][r-(1<<(logQ))+1][logQ]);
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>m;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cin>>a[0][i][j];
            a[1][i][j]=a[0][i][j];
        }
    }
    lg=log2(m);
    sparse_table();
    for(int i=0;i<n;i++)
    {
        for(int j=1;j<m;j++)
        {
            a[0][i][j]+=a[0][i][j-1];
            a[1][i][j]^=a[1][i][j-1];
        }
    }
    for(int i=1;i<n;i++)
    {
        for(int j=0;j<m;j++)
        {
            a[0][i][j]+=a[0][i-1][j];
            a[1][i][j]^=a[1][i-1][j];
        }
    }
    int q;
    cin>>q;
    int s=0,x=0,m=0;
    for(int i=0;i<q;i++)
    {
        int ra,ca,rb,cb;
        cin>>ra>>ca>>rb>>cb;
        ra--;ca--;rb--;cb--;
        if(ra==0&&ca==0)
        {
            s+=a[0][rb][cb];
            x+=a[1][rb][cb];
        }
        else if(ra==0)
        {
            s+=a[0][rb][cb]-a[0][rb][ca-1];
            x+=a[1][rb][cb]^a[1][rb][ca-1];
        }
        else if(ca==0)
        {
            s+=a[0][rb][cb]-a[0][ra-1][cb];
            x+=a[1][rb][cb]^a[1][ra-1][cb];
        }
        else
        {
            s+=a[0][rb][cb]-a[0][ra-1][cb]-a[0][rb][ca-1]+a[0][ra-1][ca-1];
            x+=a[1][rb][cb]^a[1][ra-1][cb]^a[1][rb][ca-1]^a[1][ra-1][ca-1];
        }
        int mina=1e9;
        for(int p=ra;p<=rb;p++)
        {
            mina=min(mina,RMQ(p,ca,cb));
        }
       // cout<<mina<<endl;
        m+=mina; //cout<<s<<" "<<x<<" "<<m<<endl;
    }
    cout<<s<<" "<<x<<" "<<m<<endl;
}
