#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long MAXN=1025;
long long a[2][MAXN][MAXN];
long long st[MAXN][MAXN][20];
long long n,m;
long long lg=0;
void sparse_table()
{
    for(long long i=0; i<n; i++)
    {
        for(long long j=0; j<m; j++)
        {
            st[i][j][0]=a[0][i][j];
        }
    }
    for(long long k=0; k<n; k++)
    {
        for(long long j=1; j<=lg; j++)
        {
            for(long long i=0; i<m; i++)
            {
                st[k][i][j]=min(st[k][i][j-1],st[k][i+(1<<(j-1))][j-1]);
            }
        }
    }
}
long long RMQ(long long s, long long e, long long l,long long r)
{
    long long logQ=log2(r-l+1);
    long long minq=1e9;
    for(int i=s;i<=e;i++)
    {
        minq=min(minq,min(st[i][l][logQ],st[i][r-(1<<(logQ))+1][logQ]));
    }
    return minq;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>m;
    for(long long i=0; i<n; i++)
    {
        for(long long j=0; j<m; j++)
        {
            cin>>a[0][i][j];
            a[1][i][j]=a[0][i][j];
        }
    }
    lg=log2(m);
    sparse_table();
    for(long long i=0;i<n;i++)
    {
        for(long long j=1;j<m;j++)
        {
            a[0][i][j]+=a[0][i][j-1];
            a[1][i][j]^=a[1][i][j-1];
        }
    }
    for(long long i=1;i<n;i++)
    {
        for(long long j=0;j<m;j++)
        {
            a[0][i][j]+=a[0][i-1][j];
            a[1][i][j]^=a[1][i-1][j];
        }
    }
    long long q;
    cin>>q;
    long long s=0,x=0,m=0;
    for(long long i=0;i<q;i++)
    {
        long long ra,ca,rb,cb;
        cin>>ra>>ca>>rb>>cb;
        ra--;ca--;rb--;cb--;
        if(ra==0&&ca==0)
        {
            s+=a[0][rb][cb];
            x+=a[1][rb][cb];
        }
        else if(ra==0)
        {
            s+=a[0][rb][cb]-a[0][rb][ca-1];
            x+=a[1][rb][cb]^a[1][rb][ca-1];
        }
        else if(ca==0)
        {
            s+=a[0][rb][cb]-a[0][ra-1][cb];
            x+=a[1][rb][cb]^a[1][ra-1][cb];
        }
        else
        {
            s+=a[0][rb][cb]-a[0][ra-1][cb]-a[0][rb][ca-1]+a[0][ra-1][ca-1];
            x+=a[1][rb][cb]^a[1][ra-1][cb]^a[1][rb][ca-1]^a[1][ra-1][ca-1];
        }
       // cout<<mina<<endl;
        //m+=RMQ(ra,rb,ca,cb); //cout<<s<<" "<<x<<" "<<m<<endl;
    }
    cout<<s<<" "<<x<<" "<<m<<endl;
}
