#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2e5+5;
int a[MAXN];
int b[MAXN];
int t[MAXN];
int n;

vector <pair<int, int>> v;

bool needs(int ind, int l, int r, int dir)
{
    int contains = 0;
    for (int i = 1; i <= n; i++)
        if (b[i] == a[ind] && b[i] != a[i]) contains = 1;
    if (!contains) return 0;

    if (dir == 1)
    {
        int cnt1 = 0;
        int cnt2 = 0;
        for (int i = r+1; i < n; i++)
        {
            if (a[i] == a[ind]) cnt1++;
            if (b[i] == a[ind]) cnt2++;
        }
        if (cnt2 == 0) return 0; ///
        if (cnt1 == 0 && cnt2 > 0) return 1;
    }

    return 0;
}

bool setmax(int le, int ri, int dir)
{
    if (le == ri) return 0;

    int maxi = -1;
    for (int i = le; i <= ri; i++)
    {
        maxi = max(maxi, a[i]);
    }

    ///
    for (int i = le; i <= ri; i++)
    {
        if (a[i] != maxi && needs(i, le, ri, dir))
            return 0;
    }

    for (int i = le; i <= ri; i++)
        a[i] = maxi;

//        for (int i = 0; i < n; i++)
//            cerr << a[i] << " "; cerr << endl;


    v.push_back({le, ri});
    return 1;
}

bool tryChange(int ind, int dir)
{
    int i = ind;
    int found = -1;
    int hasBigger = 0;
    while (i >= 0 && i < n)
    {
        if (a[i] > b[ind]) hasBigger = 1;
        if (a[i] == b[ind])
        {
            found = i;
            break;
        }

        i += dir;
    }

    if (found == -1) return 0;
    if (hasBigger) return 0;

//    cerr << "| " << found << endl;

    int le = min(i, ind);
    int ri = max(i, ind);

    return setmax(le, ri, dir);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        t[i] = a[i];
    }

    for (int i = 0; i < n; i++)
        cin >> b[i];


    int L = 0, R = n-1;
    int cnt = 0;

    while (L <= R)
    {
        if (tryChange(L, +1)) L++;
        if (tryChange(R, -1)) R--;

        if (cnt++ > 2 * n) break;
    }


    bool bl = 1;
    for (int i = 1; i <= n; i++)
    {
        if (a[i] != b[i]) bl = 0;
    }

    if (bl && v.size() <= n)
    {
        cout << v.size() << endl;
        for (auto x: v)
            cout << x.first << " " << x.second << endl;
    }

    else cout << -1 << endl;

    return 0;
}
/**
5
2 4 3 2 1
4 4 4 3 2

3
3 4
2 3
0 2

*/
