#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2e5+5;

struct Point
{
    int x, y;
};

int n, k;
Point a[MAXN];

bool cmp(Point a, Point b)
{
    if (a.x != b.x) return a.x < b.x;
    return a.y < b.y;
}

int dist(Point a, Point b)
{
    return abs(a.x-b.x) + abs(a.y-b.y);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n; cin >> n;
    int k; cin >> k;

    for (int i = 1; i <= n; i++)
    {
        cin >> a[i].x >> a[i].y;
        ///
    }

    sort(a+1, a+n+1, cmp);

    int ans = 0;
    int left = 1;

    for (int i = 1; i <= n; i++)
    {
        while (left < i && dist(a[left], a[i]) > k)
            left++;
        ans += (i - left);
//        cerr << i - left << endl;
    }

    cout << ans << endl;

    return 0;
}
/**
4 1
0 0
0 1
1 0
1 1

4

4 1
0 1
0 1
1 1
1 1

*/
