#include<bits/stdc++.h>
using namespace std;
long long n,m,a[1025][1025],s,mi,tmi,xo,ps[1025][1025],pxo[1025][1025],qx1,qx2,qy1,qy2;
map<long long,long long> tree;

void build(int x1, int y1, int x2, int y2, int k){
    if(x1==x2 && y1==y2){
        tree[k]=a[x1][y1];
        return;
    }
    int midx=(x1+x2)/2;
    int midy=(y1+y2)/2;
    build(x1,y1,midx,midy,k*4);
    build(midx+1,y1,x2,midy,k*4+1);
    build(x1,midy+1,midx,y2,k*4+2);
    build(midx+1,midy+1,x2,y2,k*4+3);
    tree[k]=min(min(tree[k*4],tree[k*4+1]),min(tree[k*4+2],tree[k*4+3]));
}

void query(int x1, int y1, int x2, int y2, int k){
    if(qx1<=x1 && x2<=qx2 && qy1<=y1 && y2<=qy2){
        tmi=min(tmi,tree[k]);
        return;
    }
    if(x2<qx1 || x1>qx2 || y2<qy1 || y1>qy2) return;
    int midx=(x1+x2)/2;
    int midy=(y1+y2)/2;
    query(x1,y1,midx,midy,k*4);
    query(midx+1,y1,x2,midy,k*4+1);
    query(x1,midy+1,midx,y2,k*4+2);
    query(midx+1,midy+1,x2,y2,k*4+3);
}

int main()
{
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int i,j,q;

cin>>n>>m;
for(i=1;i<=n;i++){
    for(j=1;j<=m;j++){
        cin>>a[i][j];
        ps[i][j]=a[i][j]+ps[i-1][j]+ps[i][j-1]-ps[i-1][j-1];
        pxo[i][j]=a[i][j]^pxo[i-1][j]^pxo[i][j-1]^pxo[i-1][j-1];
    }
}
build(1,1,n,m,1);

cin>>q;
while(q--){
    cin>>qx1>>qy1>>qx2>>qy2;
    s+=ps[qx2][qy2]-ps[qx1-1][qy2]-ps[qx2][qy1-1]+ps[qx1-1][qy1-1];
    xo+=pxo[qx2][qy2]^pxo[qx1-1][qy2]^pxo[qx2][qy1-1]^pxo[qx1-1][qy1-1];
    tmi=INT_MAX;
    query(1,1,n,m,1);
    mi+=tmi;
}

cout<<s<<" "<<xo<<" "<<mi;


return 0;
}
