#include<bits/stdc++.h>

#define MAXN 1028
using namespace std;

int n, m, arr[100][100], st[100][11][100][11];
long long ans;
int q;

void buildSparse()
{
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            st[i][0][j][0] = arr[i][j];
        }
    }
    for(int i = 0; i < n; i ++)
    {
        for(int c = 1; (1 << c) <= m; c ++)
        {
            for(int j = 0; j + (1 << c) <= m; j ++)
            {
                st[i][0][j][c] = min(st[i][0][j][c - 1], st[i][0][j + (1 << (c - 1))][c - 1]);
                //deb(i, 0, j, c);
                //deb(i, 0, j, c - 1);
                //deb(i, 0, j + (1 << (c - 1)), c - 1);
                //cout<<endl;
            }
        }
    }
    for(int r = 1; (1 << r) <= n; r ++)
    {
        for(int i = 0; i + (1 << r) <= n; i ++)
        {
            for(int c = 0; (1 << c) <= m; c ++)
            {
                for(int j = 0; j + (1 << c) <= m; j ++)
                {
                    st[i][r][j][c] = min(st[i][r - 1][j][c], st[i + (1 << (r - 1))][r - 1][j][c]);
                }
            }
        }
    }
}
int pw(int p)
{
    if(p == 1) return 0;
    int ret = 0;
    while(p != 0)
    {
        //cout<<p<<endl;
        p /= 2;
        ret ++;
    }
    return ret - 1;
}
int query(int l, int r, int u, int d)
{
    if(r < l) swap(l, r);
    if(d < u) swap(u, d);
    int x = abs(r - l) + 1, y = abs(u - d) + 1;
    int pwX = pw(x);
    int pwY = pw(y);
    //cout<<x<<" "<<pwX<<endl;
    //deb(u, pwY, l, pwX);
    //deb(u, pwY, r - (1 << (pwX)) + 1, pwX);
    //deb(d - (1 << pwY) + 1, pwY, l, pwX);
    //deb(d - (1 << pwY) + 1, pwY, r - (1 << (pwX)) + 1, pwX);
    return min(min(st[u][pwY][l][pwX], st[u][pwY][r - (1 << (pwX)) + 1][pwX]), min(st[d - (1 << pwY) + 1][pwY][l][pwX], st[d - (1 << pwY) + 1][pwY][r - (1 << (pwX)) + 1][pwX]));
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            cin>>arr[i][j];
        }
    }
}
void solve()
{
    cin>>q;
    int x, y, z, w;
    while(q --)
    {
       cin>>x>>y>>z>>w;
       ans += query(y - 1, w - 1, x - 1, z - 1);
    }
    cout<<0<<" "<<0<<" "<<ans<<endl;
}
int main()
{
    read();
    buildSparse();
    solve();
    return 0;
}




