#include<iostream>
using namespace std;
const int MAXN=100004;
typedef long long ll;
int n,m,a[1030][1030];
ll prefsum[1030][1030],prefxor[1030][1030];
int get_sum(int x,int y,int x1,int y1){
    return prefsum[x1][y1]-prefsum[x-1][y1]-prefsum[x1][y-1]+prefsum[x-1][y-1];
}
int get_xor(int x,int y,int x1,int y1){
    return prefxor[x1][y1]^prefxor[x-1][y1]^prefxor[x1][y-1]^prefxor[x-1][y-1];
}
int SpT[70][1030][15];
void build(){
    for(int red=0;red<n;red++){
        for(int i=0;i<m;i++){
            SpT[red][i][0]=a[red][i];
        }
        for(int k=1;k<13;k++){
            for(int i=0;i<m;i++){
                int len=i+(1<<(k-1));
                if(len<m){
                    SpT[red][i][k]=min(SpT[red][i][k-1],SpT[red][len][k-1]);
                }else{
                    SpT[red][i][k]=1030;
                }
            }
        }
    }
}
int logar(int ch){
    int x=1,br=0;
    while(x<ch){
        br++;
        x*=2;
    }
    return br;
}
int get_min(int l,int r,int red){
    l--;r--;red--;
    if(l==r){
        return a[red][l];
    }
    if(l>r){
        swap(l,r);
    }
    int k=logar(r-l+1)-1;
    return min(SpT[red][l][k],SpT[red][r-(1<<k)+1][k]);
}
int get_min_range(int x,int y,int x1,int y1){
    int res=1030;
    for(int i=x;i<=x1;i++){
        res=min(res,get_min(y,y1,i));
    }
    return res;
}
ll ansS=0,ansX=0,ansM=0;
int main(){
    cin>>n>>m;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>a[i][j];
        }
    }
    if(n<70&&m<1030){
        build();
    }
    for(int i=0;i<n;i++){
        prefsum[i][0]=0;
        prefxor[i][0]=0;
    }
    for(int i=0;i<m;i++){
        prefsum[0][i]=0;
        prefxor[0][i]=0;
    }
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            prefsum[i][j]=prefsum[i-1][j]+prefsum[i][j-1]-prefsum[i-1][j-1]+a[i-1][j-1];
            prefxor[i][j]=prefxor[i-1][j]^prefxor[i][j-1]^prefxor[i-1][j-1]^a[i-1][j-1];
        }
    }
    int q,r1,c1,r2,c2;
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>r1>>c1>>r2>>c2;
        ansS+=get_sum(r1,c1,r2,c2);
        ansX+=get_xor(r1,c1,r2,c2);
        if(n<70&&m<1030){
            ansM+=get_min_range(r1,c1,r2,c2);
        }
    }
    cout<<ansS<<" "<<ansX<<" "<<ansM;
    return 0;
}
