#include<iostream>
using namespace std;
const int MAXN = 1027;
const int MAXM = 1027;
const int LOG = 11;
const long long int INF = 1e9+9;
int lg[MAXN];
long long a[MAXN][MAXM];
long long sum[MAXN][MAXM],x[MAXN][MAXM];
long long RMQ[MAXN][MAXM][LOG];
int main(){
    int T=1;
    for(int i=2;i<MAXN;i++){
        lg[i]=lg[i-1];
        if(i==(1<<T)) lg[i]++,T++;
    }
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n,m;
    cin>>n>>m;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>a[i][j];
            if(i==0 && j==0) sum[0][0]=a[0][0];
            else if(i==0) sum[0][j]=sum[0][j-1]+a[0][j];
            else if(j==0) sum[i][0]=sum[i-1][0]+a[i][0];
            else sum[i][j]=sum[i][j-1]+sum[i-1][j]-sum[i-1][j-1]+a[i][j];
            if(i==0 && j==0) x[0][0]=a[0][0];
            else if(i==0) x[0][j]=x[0][j-1]^a[0][j];
            else if(j==0) x[i][0]=x[i-1][0]^a[i][0];
            else x[i][j]=x[i-1][j]^x[i][j-1]^x[i-1][j-1]^a[i][j];
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            RMQ[i][j][0]=a[i][j];
        }
    }
    for(int i=0;i<n;i++){
        for(int log=1;log<LOG;log++){
            for(int j=0;j<m;j++){
                RMQ[i][j][log]=min(RMQ[i][j][log-1],RMQ[i][j+(1<<(log-1))][log-1]);
            }
        }
    }
    int q;
    cin>>q;
    int x1,y1,x2,y2;
    long long SUM=0,ans=0,MIN=0;
    long long curr_sum,curr_x,curr_min;
    while(q--){
        cin>>x1>>y1>>x2>>y2;
        x1--; y1--; x2--; y2--;
        curr_sum=sum[x2][y2];
        curr_x=x[x2][y2];
        curr_min=INF;
        for(int i=x1;i<=x2;i++){
            if(y2==y1){
                curr_min=min(curr_min,a[i][y1]);
                continue;
            }
            int curr=lg[y2-y1];
            // cout<<curr<<" ";
            curr_min=min(curr_min,min(RMQ[i][y1][curr],RMQ[i][y1+(1<<curr)][curr]));
        }
        if(x1==0 && y1!=0){
            curr_sum-=sum[x2][y1-1];
            curr_x^=x[x2][y1-1];
        }else if(y1==0 && x1!=0){
            curr_sum-=sum[x1-1][y2];
            curr_x^=x[x1-1][y2];
        }else if(x1!=0 && y1!=0){
            curr_sum=sum[x2][y2]-sum[x2][y1-1]-sum[x1-1][y2]+sum[x1-1][y1-1];
            curr_x^=(x[x2][y1-1]^x[x1-1][y2]^x[x1-1][y1-1]);
        }
        SUM+=curr_sum;
        ans+=curr_x;
        MIN+=curr_min;
        // cout<<curr_min<<"\n";
    }
    cout<<SUM<<" "<<ans<<" "<<MIN<<"\n";
    return 0;
}
