#include <bits/stdc++.h>
using namespace std;
struct Point{
    int x;
    int y;
    int sum;
};
int n, k;
const int MAX_N = 500000;
Point arr[MAX_N];
bool cmp(Point a, Point b)
{
    return a.sum < b.sum;
}
int manhatan(Point a, Point b)
{
    return abs(a.x - b.x) + abs(a.y - b.y);
}
int binary(int first, int last)
{
    int l = first;
    int r = last;
    if(manhatan(arr[first], arr[last]) <= k)
    {
        return last;
    }
    if(manhatan(arr[last], arr[last - 1]) > k)
    {
        return 0;
    }
    while(l != r - 1)
    {
        int mid = (l + r) / 2;
        if(manhatan(arr[last], arr[mid]) <= k)
        {
            r = mid;
        }
        else
        {
            l = mid;
        }
    }
    return last - r - 1;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> k;
    for(int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        arr[i].x = x;
        arr[i].y = y;
        arr[i].sum = x + y;
    }
    sort(arr, arr + n, cmp);
    int res = 0;
    for(int i = 1; i < n; i++)
    {
        //cout << "za: " << arr[i].x << ", " << arr[i].y << "->" << binary(0, i) << endl;
        res += binary(0, i);
    }
    /*int res = 0;
    for(int i = 0; i < n; i++)
    {
        for(int j = i + 1; j < n; j++)
        {
            if(abs(arr[i].x - arr[j].x) + abs(arr[i].y - arr[j].y) <= k)
            {
                res++;
            }
        }
    }*/
    cout << res;
    return 0;
}
