#include <bits/stdc++.h>
using namespace std;
int sums[1024][1024], xors[1024][1024], mins[1024][4096];
void buildTree(int tree[], int arr[], int parent, int first, int last) {
    if(first == last) {
        tree[parent] = arr[first];
        return;
    }

    int mid = (first + last) / 2;
    buildTree(tree, arr, 2 * parent, first, mid);
    buildTree(tree, arr, 2 * parent + 1, mid + 1, last);
    tree[parent] = min(tree[2 * parent], tree[2 * parent + 1]);
}

int query(int tree[], int parent, int first, int last, int from, int to) {
    if(first > to || last < from) return INT_MAX;

    if(first >= from && last <= to) {
        return tree[parent];
    }

    int m = INT_MAX;
    int mid = (first + last) / 2;
    m = min(m, query(tree, 2 * parent, first, mid, from, to));
    m = min(m, query(tree, 2 * parent + 1, mid + 1, last, from, to));

    return m;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int N, M;
    cin >> N >> M;
    int table[N][M];
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            cin >> table[i][j];
            if(j == 0) {
                sums[i][j] = table[i][j];
                xors[i][j] = table[i][j];
            } else {
                sums[i][j] = sums[i][j - 1] + table[i][j];
                xors[i][j] = xors[i][j - 1] ^ table[i][j];
            }
        }
        //buildTree(mins[i], table[i], 1, 0, M - 1);
    }

    int q;
    cin >> q;
    long long s = 0, x = 0, m = 0;
    while(q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        r1--; c1--; r2--; c2--;
        int currs = 0, currx = 0, currm = INT_MAX;
        for(int i = r1; i <= r2; i++) {
            if(c1 == 0) {
                currs += sums[i][c2];
                currx ^= xors[i][c2];
            } else {
                currs += sums[i][c2] - sums[i][c1 - 1];
                currx ^= (xors[i][c2] ^ xors[i][c1 - 1]);
            }
            //currm = min(currm, query(mins[i], 1, 0, M - 1, c1, c2));
        }
        s += currs;
        x += currx;
        //m += currm;
    }

    cout << s << " " << x << " " << m;




    return 0;
}
