#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <vector>
using namespace std;
const int MAXN = 2 * 1e5 + 1;
pair<long long, int> brr[MAXN];
int arr[MAXN], target[MAXN];
unordered_map<long long, int> compr;
set<int> pos[MAXN];
vector< pair< pair<int, int>, pair<int, int> > > seg; //l, r, target, val
int choice[MAXN];
int sparse[MAXN][20];
int log[MAXN];
int pow(int b, int e) {
    if (e == 0) {
        return 1;
    }
    int power = pow(b, e / 2);
    if (e % 2 == 0) {
        return power * power;
    } else {
        return power * power * b;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> brr[i].first;
        brr[i].second = i;
    }
    sort(brr + 1, brr + n + 1);
    int curr = 0;
    brr[0] = {0, 0};
    for (int i = 1; i <= n; i++) {
        if (brr[i].first != brr[i - 1].first) {
            curr++;
            compr[brr[i].first] = curr;
        }
        arr[brr[i].second] = curr;
        pos[curr].insert(brr[i].second);
    }
    bool dead = false;
    for (int i = 1; i <= n; i++) {
        cin >> target[i];
        if (compr.count(target[i]) == 0) {
            dead = true;
        } else {
            target[i] = compr[target[i]];
        }
    }
    if (dead) {
        cout << -1;
        return 0;
    }
    int num = 0;
    for (int i = 1; i <= n; i++) {
        if (arr[i] != target[i]) {
            if (arr[i] > target[i] || pos[target[i]].empty()) {
                cout << -1;
                return 0;
            }
            set<int>::iterator ptr = pos[target[i]].upper_bound(i);
            int l, r;
            if (ptr == pos[target[i]].end()) {
                r = i;
                if (choice[seg.size()] == 1) {
                    cout << -1;
                    return 0;
                }
                choice[seg.size()] = -1;
            } else {
                r = *ptr;
            }
            if (ptr == pos[target[i]].begin()) {
                l = i;
                if (choice[seg.size()] == -1) {
                   cout << -1;
                   return 0;
                }
                choice[seg.size()] = 1;
            } else {
                ptr--;
                l = *ptr;
            }
            seg.push_back({{l, r}, {i, target[i]}});
        } else {
            num++;
            seg.push_back({{i, i}, {i, target[i]}});
        }
    }
    sort(seg.begin(), seg.end());
    int prob = 0;
    int prev = 0;
    for (int i = 1; i < seg.size(); i++) {
        if (prob != 0 && seg[i].first.second >= seg[prob].second.first) {
            if (seg[i].first.first <= seg[prob].first.second) {
                cout << -1;
                return 0;
            }
            prob = 0;
        }
        if (seg[prev].first.first == seg[prev].first.second) {
            prev = i;
            continue;
        }
        if (seg[i].first.first == seg[i - 1].first.first) {
            if (choice[i] != 0 && choice[prev] != 0 && choice[i] != choice[prev]) {
                cout << -1;
                return 0;
            }
            choice[i] = choice[prev];
            seg[prev]= {{seg[prev].first.first, seg[prev].first.first}, {seg[prev].first.first, target[seg[prev].first.first]}};
            if (prev > 0) {
                prev--;
                i--;
            }
            num++;
            continue;
        }
        if (seg[i].first.first < seg[prev].first.second) {
            if (seg[i].first.second > seg[prev].first.second) {
                cout << -1;
                return 0;
            }
            if (seg[i].second.second == seg[prev].second.second) {
                if (seg[prev].first.first != seg[prev].first.second) {
                    prev = i;
                }
                continue;
            }
            if (seg[prev].second.first < seg[i].second.first) {
                if (choice[prev] == 1) {
                    cout << -1;
                    return 0;
                }
                choice[prev] = -1;
                if (seg[i].first.first != seg[i].first.second && seg[i].second.second > seg[prev].second.second) {
                    if (seg[i].first.first <= seg[prev].second.first) {
                        if (choice[i] == -1) {
                            cout << -1;
                            return 0;
                        }
                        choice[i] = 1;
                        prob = i;
                    }
                }
            }
            if (seg[prev].second.first > seg[i].second.first) {
                if (choice[prev] == -1) {
                    cout << -1;
                    return 0;
                }
                choice[prev] = 1;
                prob = prev;
                if (seg[i].second.second > seg[prev].second.second) {
                    if (seg[i].first.first != seg[i].first.second && seg[i].first.second >= seg[prev].second.first) {
                        if (choice[i] == 1) {
                            cout << -1;
                            return 0;
                        }
                        choice[i] = -1;
                    }
                }
            }
        }
        if (seg[prev].first.first != seg[prev].first.second) {
            prev = i;
        }
    }
    for (int i = 1; i <= n; i++) {
        sparse[i][0] = arr[i];
    }
    int power = 2, exp = 1;
    for (; power < n; power *= 2) {
        for (int i = 1; i <= n; i++) {
            sparse[i][exp] = max(sparse[i][exp - 1], sparse[min(n, i + power / 2)][exp - 1]);
        }
        exp++;
    }
    power = 1;
    exp = 0;
    for (int i = 1; i <= n; i++) {
        if (i == power) {
            power *= 2;
            exp++;
        }
        log[i] = exp - 1;
    }
    for (int i = 0; i < seg.size(); i++) {
        auto it = seg[i];
        int l = it.first.first, r = it.first.second, mid = it.second.first, val = target[mid];
        if (max(sparse[l][log[mid - l + 1]], sparse[mid - pow(2, log[mid - l + 1]) + 1][log[mid - l + 1]]) > val) {
            if (choice[i] == -1) {
                cout << -1;
                return 0;
            }
            choice[i] = 1;
        }
        if (max(sparse[mid][log[r - mid + 1]], sparse[r - pow(2, log[r - mid + 1]) + 1][log[r - mid + 1]]) > val) {
            if (choice[i] == 1) {
                cout << -1;
                return 0;
            }
            choice[i] = -1;
        }
    }
    for (int i = 0; i < seg.size(); i++) {
//        cout << seg[i].first.first - 1 << ' ' << seg[i].second.first - 1 << ' ' << seg[i].first.second - 1 << ' ' << choice[i] << '\n';
        if (seg[i].first.first == seg[i].first.second) {
            seg[i] = {{target[seg[i].second.first], seg[i].second.first}, {seg[i].first.first, seg[i].first.second}};
            continue;
        }
        if (choice[i] == 1) {
            seg[i] = {{target[seg[i].second.first], seg[i].second.first}, {seg[i].second.first, seg[i].first.second}};
        } else if (choice[i] == -1) {
            seg[i] = {{target[seg[i].second.first], seg[i].second.first}, {seg[i].first.first, seg[i].second.first}};
        } else {
            seg[i] = {{target[seg[i].second.first], seg[i].second.first}, {seg[i].first.first, seg[i].first.second}};
        }
    }
//    return 0;
    sort(seg.begin(), seg.end());
    cout << seg.size() - num << '\n';
    for (int i = 0; i < seg.size(); i++) {
        if (seg[i].second.first == seg[i].second.second) {
            continue;
        }
        cout << seg[i].second.first - 1 << ' ' << seg[i].second.second - 1 << '\n';
    }
    return 0;
}

