#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
const int MAXN = 2*1e5+7;
int a[MAXN],b[MAXN],nb[MAXN];
pair<int,int> c[MAXN]; /// chislo i originalen idx
vector<pair<int,int>> op;
bool el(pair<int,int> x,pair<int,int> y){
    if(x.first==y.first) return x.second<y.second;
    return x.first<y.first;
}
int treemax[4*MAXN];
int treemin[4*MAXN];
void build_tree(int ind,int l,int r){
    if(l==r){
        treemax[ind]=a[l];
        treemin[ind]=b[l];
        return;
    }
    int m = (l+r)/2;
    build_tree(2*ind,l,m);
    build_tree(2*ind+1,m+1,r);
    treemax[ind]=max(treemax[2*ind],treemax[2*ind+1]);
    treemin[ind]=min(treemin[2*ind],treemin[2*ind+1]);
    return;
}
void update(int ind,int l,int r,int ql,int qr,int val){
    if(l==r){
        treemax[ind]=val;
        return;
    }
    int m = (l+r)/2;
    if(ql<=m) update(2*ind,l,m,ql,qr,val);
    if(qr>m) update(2*ind+1,m+1,r,ql,qr,val);
    treemax[ind]=max(treemax[2*ind],treemax[2*ind+1]);
    return;
}
int querymax(int ind,int l,int r,int ql,int qr){
    if(ql<=l && r<=qr){
        return treemax[ind];
    }
    int ans = 0;
    int m = (l+r)/2;
    if(ql<=m) ans = querymax(2*ind,l,m,ql,qr);
    if(qr>m) ans = max(ans,querymax(2*ind+1,m+1,r,ql,qr));
    return ans;
}
int querymin(int ind,int l,int r,int ql,int qr){
    if(ql<=l && r<=qr){
        return treemin[ind];
    }
    int ans = MAXN;
    int m = (l+r)/2;
    if(ql<=m) ans = querymin(2*ind,l,m,ql,qr);
    if(qr>m) ans = min(ans,querymin(2*ind+1,m+1,r,ql,qr));
    return ans;
}
int main () {
    int n;
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    for(int i=0;i<n;i++){
        cin>>b[i];
        c[i]={b[i],i};

    }
    sort(c,c+n,el);
    int p,q;
    build_tree(1,0,n-1);
    for(int i=0;i<n;i++){
        nb[i]=-1;
        for(int j=0;j<n;j++){
            if(a[j]==c[i].first){
                p=querymax(1,0,n-1,min(c[i].second,j),max(c[i].second,j));
                q=querymin(1,0,n-1,min(c[i].second,j),max(c[i].second,j));
                //cout<<" za "<<c[i].first<<" p["<<j<<"] = "<<p<<" i q("<<min(c[i].second,j)<<","<<max(c[i].second,j)<<") = "<<q<<"\n";
                if(p==c[i].first and q>=c[i].first){
                    nb[i]=j;
                    break;
                }
            }
        }
        //cout<<"za "<<c[i].first<<" nai-blizo e "<<nb[i]<<"\n";
    }
    for(int i=0;i<n;i++){
        if(nb[i]==-1){
            cout<<-1<<"\n";
            return 0;
        }
        p = querymax(1,0,n-1,min(c[i].second,nb[i]),max(c[i].second,nb[i]));
        if(p>c[i].first){
            cout<<-1<<"\n";
            return 0;
        }else{
            op.push_back({min(c[i].second,nb[i]),max(c[i].second,nb[i])});
            update(1,0,n-1,min(c[i].second,nb[i]),max(c[i].second,nb[i]),p);
        }
    }
    cout<<op.size()<<"\n";
    for(auto to:op){
        cout<<to.first<<" "<<to.second<<"\n";
    }
    return 0;
}
