#include<iostream>
using namespace std;
const int MAXN = 1030;
int ksor[MAXN][MAXN];
long long sum[MAXN][MAXN];
int a[MAXN][MAXN];
int tree[MAXN][2*MAXN];
void build(int ind,int l,int r,int bigind){
    if(l==r){
        tree[bigind][ind]=a[bigind][l];
        return;
    }
    int m = (l+r)/2;
    build(2*ind,l,m,bigind);
    build(2*ind+1,m+1,r,bigind);
    tree[bigind][ind]=min(tree[bigind][2*ind],tree[bigind][2*ind+1]);
    return;
}
int currmin;
void query(int ind,int l,int r,int ql,int qr,int bigind){
    if(ql<=l && r<=qr){
        currmin = min(currmin,tree[bigind][ind]);
        return;
    }
    int m=(l+r)/2;
    if(ql<=m) query(2*ind,l,m,ql,qr,bigind);
    if(qr>m) query(2*ind+1,m+1,r,ql,qr,bigind);
}
int main() {
    int n,m;
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            cin>>a[i][j];
            sum[i][j]=sum[i][j-1]+sum[i-1][j]-sum[i-1][j-1]+a[i][j];
            ksor[i][j]=ksor[i][j-1]^ksor[i-1][j]^ksor[i-1][j-1]^a[i][j];
        }
    }
    for(int i=1;i<=n;i++){
        build(1,1,n,i);
    }
    int q;
    long long suma = 0;
    int XOR = 0,MIN=0;
    cin>>q;
    int i1,j1,i2,j2;
    while(q--){
        cin>>i1>>j1>>i2>>j2;
        currmin = a[i1][j1];
        for(int i=i1;i<=i2;i++){
            query(1,1,n,j1,j2,i);
        }
        MIN+=currmin;
        suma+=sum[i2][j2]-sum[i2][j1-1]-sum[i1-1][j2]+sum[i1-1][j1-1];
        XOR+=ksor[i2][j2]^ksor[i2][j1-1]^ksor[i1-1][j2]^ksor[i1-1][j1-1];
    }
    cout<<suma<<" "<<XOR<<" "<<MIN<<"\n";
    return 0;
}


