#include<bits/stdc++.h>
#pragma GCC optimize "O3"
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=1030;
const int mod=1e9+7;

int n, m, q;
ll prefix[maxn][maxn];
ll a[maxn][maxn];
ll x[maxn][maxn];
ll mins[maxn][maxn];

ll ans_p=0, ans_x=0, ans_m=0;

int main() {
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;

for(int i=1; i<=n; i++){
    for(int j=1; j<=m; j++){
        cin>>a[i][j];
    }
}

for(int i=1; i<=n; i++){
    for(int j=1; j<=m; j++){
        prefix[i][j] = a[i][j] + prefix[i-1][j] + prefix[i][j-1] - prefix[i-1][j-1];
        x[i][j] = a[i][j] ^ x[i-1][j] ^ x[i][j-1] ^ x[i-1][j-1];
        mins[i][j] = min(a[i][j], min(mins[i-1][j], mins[i][j-1]));
    }
}

cin>>q;

while(q--){
    int x1, x2, y1, y2;
    cin>>x1>>y1>>x2>>y2;

    ans_p+=prefix[x2][y2] - prefix[x2][y1-1] - prefix[x1-1][y2] + prefix[x1-1][y1-1];
    ans_x+=x[x2][y2] ^ x[x2][y1-1] ^ x[x1-1][y2] ^ x[x1-1][y1-1];

    ll curr_min=INT_MAX;
    for(int i=x1; i<=x2; i++){
        for(int j=y1; j<=y2; j++){
            curr_min=min(curr_min, a[i][j]);
            if(curr_min==0){
                break;
            }
        }
    }
    ans_m+=curr_min;
}
cout<<ans_p<<" "<<ans_x<<" "<<ans_m<<endl;

return 0;
}



