#include<bits/stdc++.h>
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=1e5+3;
const int mod=1e9+7;

int n, k;
vector<pii> points;
vector<pii> curr;
int x, y;

bool cmp(pii left, pii right){
    return abs(left.first-x) + abs(left.second - y) <
           abs(right.first-x) + abs(right.second-y);
}

int bs(int idx){
    int l=0, r=curr.size()-1, m;
    int prev_m=-1;

    if(abs(curr[0].first - x) + abs(curr[0].second - y) > k) return -1;

    while(l!=r-1){
        m=(l+r)/2;

        if(prev_m==m) return l;

        if(abs(curr[m].first - x) + abs(curr[m].second - y) <= k) l=m;
        else r=m;

        prev_m=m;
    }
    return l;
}

int main() {
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>k;
for(int i=0; i<n; i++){
    int a, b;
    cin>>a>>b;

    points.pb({a, b});
}

ll nas=0;
for(int i=0; i<n; i++){

    curr.clear();

    for(int j=i+1; j<n; j++){
        curr.pb(points[j]);
    }

    x=points[i].first;
    y=points[i].second;

    sort(curr.begin(), curr.end(), cmp);

    /*cout<<"sorted for "<<x<<" "<<y<<":"<<endl;
    for(auto pt: curr){
        cout<<pt.first<<" "<<pt.second<<endl;
    }
    cerr<<bs(i)<<endl<<endl;
    */
    nas+=bs(i)+1;
}
cout<<nas-1<<endl;


return 0;
}
