#include<bits/stdc++.h>
#define lli int
#define endl "\n"
using namespace std;
const lli MAXN=1030;
struct node{
    lli x, s, m;
};
node tree[4*MAXN][4*MAXN];
lli N, M, Q, r1, r2, c1, c2;//0-xor, 1-sum, 2-min
long long s, m, x;
lli mat[MAXN][MAXN];
void build_node(lli ind1, lli ind2, lli lr, lli rr, lli lc, lli rc){
    if(lc==rc and lr==rr){
        tree[ind1][ind2].x=mat[lr][lc];
        tree[ind1][ind2].s=mat[lr][lc];
        tree[ind1][ind2].m=mat[lr][lc];
        return;
    }else if(lc==rc){
        tree[ind1][ind2].x=tree[2*ind1][ind2].x^tree[2*ind1+1][ind2].x;
        tree[ind1][ind2].s=tree[2*ind1][ind2].s+tree[2*ind1+1][ind2].s;
        tree[ind1][ind2].m=min(tree[2*ind1][ind2].m, tree[2*ind1+1][ind2].m);
        return;
    }
    lli midc=(lc+rc)/2;
    build_node(ind1, 2*ind2, lr, rr, lc, midc);
    build_node(ind1, 2*ind2+1, lr, rr, midc+1, rc);
    tree[ind1][ind2].x=tree[ind1][2*ind2].x^tree[ind1][2*ind2+1].x;
    tree[ind1][ind2].s=tree[ind1][2*ind2].s+tree[ind1][2*ind2+1].s;
    tree[ind1][ind2].m=min(tree[ind1][2*ind2].m, tree[ind1][2*ind2+1].m);
    return;
}
void build(lli ind1, lli ind2, lli lr, lli rr, lli lc, lli rc){
    if(tree[ind1][ind2].x!=0)return;
    if(lr==rr){
        build_node(ind1, ind2, lr, rr, lc, rc);
        return;
    }
    lli midr=(lr+rr)/2;
    build(2*ind1, ind2, lr, midr, lc, rc);
    build(2*ind1+1, ind2, midr+1, rr, lc, rc);
    build_node(ind1, ind2, lr, rr, lc, rc);
    return;
}
node query(lli ind1, lli ind2, lli lr, lli rr, lli lc, lli rc, lli qlr, lli qrr, lli qlc, lli qrc){
    if(lr>qrr or rr<qlr)return {-1, -1, -1};
    if(lc>qrc or rc<qlc)return {-1, -1, -1};
    if(qlr<=lr and rr<=qrr and qlc<=lc and rc<=qrc){
        return tree[ind1][ind2];
    }
    if(qlr<=lr and rr<=qrr){
        lli midc=(lc+rc)/2;
        node ans1=query(ind1, 2*ind2, lr, rr, lc, midc, qlr, qrr, qlc, qrc);
        node ans2=query(ind1, 2*ind2+1, lr, rr, midc+1, rc, qlr, qrr, qlc, qrc);
        if(ans1.x<0)return ans2;
        if(ans2.x<0)return ans1;
        return {ans1.x^ans2.x, ans1.s+ans2.s, min(ans1.m, ans2.m)};
    }
    lli midr=(lr+rr)/2;
    node ans1=query(2*ind1, ind2, lr, midr, lc, rc, qlr, qrr, qlc, qrc);
    node ans2=query(2*ind1+1, ind2, midr+1, rr, lc, rc, qlr, qrr, qlc, qrc);
    if(ans1.x<0)return ans2;
    if(ans2.x<0)return ans1;
    return {ans1.x^ans2.x, ans1.s+ans2.s, min(ans1.m, ans2.m)};
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N>>M;
    for(lli i=1; i<=N; i++){
        for(lli j=1; j<=M; j++){
            cin>>mat[i][j];
        }
    }
    build(1, 1, 1, N, 1, M);
    cin>>Q;
    for(lli q=0; q<Q; q++){
        cin>>r1>>c1>>r2>>c2;
        node ans=query(1, 1, 1, N, 1, M, r1, r2, c1, c2);
        s+=ans.s;
        x+=ans.x;
        m+=ans.m;
    }
    cout<<s<<" "<<x<<" "<<m<<endl;
    return 0;
}

