#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 50;
struct Point
{
    int X, Y;
    Point(){}
    Point(int X, int Y)
        :X(X), Y(Y){}
};

bool cmp(const Point &a, const Point &b)
{
    return a.X < b.X;
}
Point points[MAXN];
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;

        points[i] = Point(x, y);
    }

    sort(points, points+n, cmp);

    int64_t ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = i+1; j < n; j++)
        {
            if (abs(points[i].X - points[j].X) + abs(points[i].Y - points[j].Y) <= k)
                ans++;
        }
    }

    cout << ans << endl;

    return 0;
}
