#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 50;
struct Point
{
    int X, Y;
    Point(){}
    Point(int X, int Y)
        :X(X), Y(Y){}
};

int n, k;
bool cmp(const Point &a, const Point &b)
{
    return a.X < b.X;
}
Point points[MAXN];

int BinarySearchL(int ind)
{
    int x = points[ind].X - k;

    int l = 0, r = n-1, ans = -1, mid;

    while (l <= r)
    {
        mid = (l+r)/2;

        if (points[mid].X < x)
            l = mid+1;

        else
        {
            ans = mid;
            r = mid-1;
        }
    }

    ans = (ind-ans + 1);
    return max(0, ans);
}

int BinarySearchR(int ind)
{
    int x = points[ind].X + k;

    int l = 0, r = n-1, ans = -1, mid;

    while (l <= r)
    {
        mid = (l+r)/2;

        if (points[mid].X <= x)
            l = mid+1;

        else
        {
            ans = mid;
            r = mid-1;
        }
    }

    ans = (ans - ind + 1);
    return max(0, ans);
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n >> k;

    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;

        points[i] = Point(x, y);
    }

    int64_t ans = 0;
    sort(points, points+n, cmp);

    for (int i = 0; i < n; i++)
    {
        ans += BinarySearchL(i) + BinarySearchR(i);
    }

    cout << ans << endl;

    return 0;
}
