#include<bits/stdc++.h>

using namespace std;
int prefix[1025][1025] ,pxor[1025][1025];
int a[1025][1025];
int tree[1025][4097];
void build_tree(int ti, int i, int l, int r)
{
    if(l==r)
    {
        tree[ti][i]=a[ti][l];
        return;
    }
    int m=(l+r)/2;
    build_tree(ti, 2*i, l, m);
    build_tree(ti, 2*i+1, m+1, r);
    tree[ti][i]=min(tree[ti][2*i], tree[ti][2*i+1]);
}
int minquery(int ti, int i, int l, int r, int ql, int qr)
{
    if(ql==l&&qr==r)
    {
        return tree[ti][i];
    }
    int m=(l+r)/2;
    if(qr<=m)
    {
        return minquery(ti, 2*i, l, m, ql, qr);
    }
    if(ql>m)
    {
        return minquery(ti, 2*i+1, m+1, r, ql, qr);
    }
    return min(minquery(ti, 2*i, l, m, ql, m), minquery(ti, 2*i+1, m+1, r, m+1, qr));
}
int N, M;
void read()
{
    cin>>N>>M;
    for(int i=1;i<=N;i++)
    {
        for(int j=1;j<=M;j++)
        {
            cin>>a[i][j];
        }
    }
    for(int i=1;i<=N;i++)
    {
        build_tree(i, 1, 1, M);
    }
}
void calc()
{
    for(int i=1;i<=N;i++)
    {
        for(int j=1;j<=M;j++)
        {
            prefix[i][j]=prefix[i][j-1]+prefix[i-1][j]-prefix[i-1][j-1]+a[i][j];
            pxor[i][j]=(((pxor[i][j-1]^pxor[i-1][j])^pxor[i-1][j-1])^a[i][j]);
        }
    }

   /*
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout<<pxor[i][j]<<" ";
        }
        cout<<endl;
    }*/
}
long long sums=0, sumx=0, summ=0;
int q;
void query()
{
    cin>>q;
    int r1, c1, r2, c2;
    for(int i=0;i<q;i++)
    {
        cin>>r1>>c1>>r2>>c2;
        sums+=(prefix[r2][c2]-prefix[r2][c1-1]-prefix[r1-1][c2]+prefix[r1-1][c1-1]);
        sumx+=(pxor[r2][c2]^pxor[r2][c1-1]^pxor[r1-1][c2]^pxor[r1-1][c1-1]);
        int minn=INT_MAX;
        for(int j=r1;j<=r2;j++)
        {
            minn=min(minn, minquery(j, 1, 1, M, c1, c2));
        }
        summ+=minn;
        //cout<<prefix[r2][c2]<<" "<<prefix[r2][c1-1]<<" "<<prefix[r1-1][c2]<<" "<<prefix[r1-1][c1-1]<<endl;
       // cout<<sum<<endl;
    }
    cout<<sums<<" "<<sumx<<" "<<summ<<endl;
}
int main()
{
    read();
    calc();
    query();
	return 0;
}
