#include <bits/stdc++.h>
using namespace std;

const int maxn = 1030, maxq = 5e5+2;
int n, m, row, ql, qr, a[maxn][maxn], q, sum[maxn][maxn], xorr[maxn][maxn], minx = INT_MAX;
int t[maxn][4*maxn];

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[row][i] = a[row][r];
        return;
    }
    int mid = (l + r) >> 1 ;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[row][i] = min(t[row][2*i], t[row][2*i+1]);
}

int query(int i, int l, int r)
{
    if (l > qr || r < ql) return INT_MAX;
    if (l >= ql && r <= qr) return t[row][i];
    int mid = (l + r) >> 1 ;
    return min (query(2*i, l, mid), query(2*i+1, mid+1, r));
}

void read()
{
    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> a[i][j] ;
            sum[i][j] = sum[i][j-1] + a[i][j];
            xorr[i][j] = (xorr[i][j-1] ^ a[i][j]);
        }
        row = i;
        make_tree(1, 1, m);
    }
}

void solve()
{
    cin >> q ;
    int i, j, r1, r2, c1, c2, p;
    long long res1, res2, res3, ans1 = 0, ans2 = 0, ans3 = 0;
    for (i=1; i<=q; ++ i)
    {
        cin >> r1 >> c1 >> r2 >> c2 ;
        res1 = 0, res2 = 0, res3 = LLONG_MAX;
        for (j=r1; j<=r2; ++j)
        {
            row = j;
            ql = c1; qr = c2;
            p = query(1, 1, m);
            res1 += (long long)(sum[j][c2] - sum[j][c1-1]);
            res3 = min(res3, (long long)(p));
            res2 = (res2 ^ (long long)(xorr[j][c2] ^ xorr[j][c1-1]));
            //cout << res1 << " " << res2 << " " << res3 << '\n' ;
        }
        ans1 += res1, ans2 += res2, ans3 += res3;
    }
    cout << ans1 << " " << ans2 << " " << ans3 << '\n' ;
}

void read1()
{
    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> a[i][j] ;
            sum[i][j] = sum[i][j-1] + a[i][j];
            xorr[i][j] = (xorr[i][j-1] ^ a[i][j]);
            if (a[i][j] < minx)
                minx = a[i][j];
        }
    }
}

void solve1()
{
    cin >> q ;
    int i, j, r1, r2, c1, c2;
    long long res1, res2, ans1 = 0, ans2 = 0, ans3 = q*minx;
    for (i=1; i<=q; ++ i)
    {
        cin >> r1 >> c1 >> r2 >> c2 ;
        res1 = 0, res2 = 0;
        for (j=r1; j<=r2; ++j)
        {
            row = j;
            res1 += (long long)(sum[j][c2] - sum[j][c1-1]);
            res2 = (res2 ^ (long long)(xorr[j][c2] ^ xorr[j][c1-1]));
            //cout << res1 << " " << res2 << " " << res3 << '\n' ;
        }
        ans1 += res1, ans2 += res2;
    }
    cout << ans1 << " " << ans2 << " " << ans3 << '\n' ;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    if (n <= 16 && m <= 16)
    {
        read();
        solve();
    }
    else
    {
        read1();
        solve1();
    }
    return 0;
}