#include <bits/stdc++.h>
using namespace std;

const int maxn = 1030, maxq = 5e5+2;
int n, m, q, a[maxn][maxn], sum[maxn][maxn], xorr[maxn][maxn], minx = INT_MAX;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;

    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> a[i][j] ;

            sum[i][j] = sum[i-1][j] + sum[i][j-1] - sum[i-1][j-1] + a[i][j];
            xorr[i][j] = ((xorr[i-1][j] ^ xorr[i][j-1]) ^ xorr[i-1][j-1]) ^ a[i][j];

            if (a[i][j] < minx)
                minx = a[i][j];
        }
    }
}

void solve()
{
    cin >> q ;
    int i, j, r1, r2, c1, c2, res1, res2;
    long long ans1 = 0, ans2 = 0, ans3 = q*minx;
    for (i=1; i<=q; ++i)
    {
        cin >> r1 >> c1 >> r2 >> c2 ;
        res1 = sum[r2][c2] - sum[r2][c1-1] - sum[r1-1][c2] + sum[r1-1][c1-1];
        res2 = (((xorr[r2][c2] ^ xorr[r2][c1-1]) ^ xorr[r1-1][c2]) ^ xorr[r1-1][c1-1]);
        ans1 += (long long)(res1), ans2 += (long long)(res2);
    }
    cout << ans1 << " " << ans2 << " " << ans3 << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}